// Verilog netlist produced by program LSE :  version Diamond (64-bit) 3.12.1.454
// Netlist written on Wed Jan 11 22:08:13 2023
//
// Verilog Description of module top
//

module top (Reset, ButtonUp, ButtonDown, Segments) /* synthesis syn_module_defined=1 */ ;   // d:/lattice/kurs06/impl1/source/top.v(1[8:11])
    input Reset;   // d:/lattice/kurs06/impl1/source/top.v(2[16:21])
    input ButtonUp;   // d:/lattice/kurs06/impl1/source/top.v(3[16:24])
    input ButtonDown;   // d:/lattice/kurs06/impl1/source/top.v(4[16:26])
    output [6:0]Segments;   // d:/lattice/kurs06/impl1/source/top.v(5[15:23])
    
    wire Clock14MHz /* synthesis SET_AS_NETWORK=Clock14MHz, is_clock=1 */ ;   // d:/lattice/kurs06/impl1/source/top.v(13[8:18])
    
    wire GND_net, Reset_c, ButtonUp_c, ButtonDown_c, Segments_c_6, 
        Segments_c_5, Segments_c_4, Segments_c_3, Segments_c_2, Segments_c_1, 
        Segments_c_0, ButtonUpFiltered, ButtonDownFiltered;
    wire [3:0]CountValue;   // d:/lattice/kurs06/impl1/source/top.v(62[13:23])
    
    wire n203;
    wire [3:0]Value_3__N_23;
    
    wire n213, n4, VCC_net, n412, n411, n385, n386;
    
    VHI i376 (.Z(VCC_net));
    OB Segments_pad_3 (.I(Segments_c_3), .O(Segments[3]));   // d:/lattice/kurs06/impl1/source/top.v(5[15:23])
    OSCH OSCH_inst (.STDBY(GND_net), .OSC(Clock14MHz)) /* synthesis syn_instantiated=1 */ ;
    defparam OSCH_inst.NOM_FREQ = "14.00";
    Decoder7seg Dekoder0 (.CountValue({CountValue}), .Segments_c_0(Segments_c_0), 
            .Segments_c_3(Segments_c_3), .Segments_c_2(Segments_c_2), .Segments_c_4(Segments_c_4), 
            .Segments_c_1(Segments_c_1), .Segments_c_6(Segments_c_6), .Segments_c_5(Segments_c_5)) /* synthesis syn_module_defined=1 */ ;   // d:/lattice/kurs06/impl1/source/top.v(76[4] 79[3])
    OB Segments_pad_0 (.I(Segments_c_0), .O(Segments[0]));   // d:/lattice/kurs06/impl1/source/top.v(5[15:23])
    OB Segments_pad_1 (.I(Segments_c_1), .O(Segments[1]));   // d:/lattice/kurs06/impl1/source/top.v(5[15:23])
    OB Segments_pad_4 (.I(Segments_c_4), .O(Segments[4]));   // d:/lattice/kurs06/impl1/source/top.v(5[15:23])
    EdgeDetector_U0 DownDetector (.ButtonDownFiltered(ButtonDownFiltered), 
            .\CountValue[0] (CountValue[0]), .n412(n412), .\Value_3__N_23[0] (Value_3__N_23[0]), 
            .n411(n411), .Clock14MHz(Clock14MHz)) /* synthesis syn_module_defined=1 */ ;   // d:/lattice/kurs06/impl1/source/top.v(53[15] 59[3])
    OB Segments_pad_5 (.I(Segments_c_5), .O(Segments[5]));   // d:/lattice/kurs06/impl1/source/top.v(5[15:23])
    OB Segments_pad_6 (.I(Segments_c_6), .O(Segments[6]));   // d:/lattice/kurs06/impl1/source/top.v(5[15:23])
    OB Segments_pad_2 (.I(Segments_c_2), .O(Segments[2]));   // d:/lattice/kurs06/impl1/source/top.v(5[15:23])
    IB Reset_pad (.I(Reset), .O(Reset_c));   // d:/lattice/kurs06/impl1/source/top.v(2[16:21])
    IB ButtonUp_pad (.I(ButtonUp), .O(ButtonUp_c));   // d:/lattice/kurs06/impl1/source/top.v(3[16:24])
    IB ButtonDown_pad (.I(ButtonDown), .O(ButtonDown_c));   // d:/lattice/kurs06/impl1/source/top.v(4[16:26])
    GSR GSR_INST (.GSR(Reset_c));
    LUT4 i358_3_lut (.A(ButtonUpFiltered), .B(ButtonUp_c), .C(n213), .Z(n386)) /* synthesis lut_function=(A (B+!(C))+!A (B (C))) */ ;
    defparam i358_3_lut.init = 16'hcaca;
    LUT4 i357_3_lut (.A(ButtonDownFiltered), .B(ButtonDown_c), .C(n203), 
         .Z(n385)) /* synthesis lut_function=(A (B+!(C))+!A (B (C))) */ ;
    defparam i357_3_lut.init = 16'hcaca;
    \Debouncer(FREQUENCY_MHZ=14,PERIOD_US=1)_U1  DebounceDown (.ButtonDownFiltered(ButtonDownFiltered), 
            .Clock14MHz(Clock14MHz), .n385(n385), .n203(n203), .ButtonDown_c(ButtonDown_c)) /* synthesis syn_module_defined=1 */ ;   // d:/lattice/kurs06/impl1/source/top.v(34[4] 39[3])
    \Debouncer(FREQUENCY_MHZ=14,PERIOD_US=1)  DebounceUp (.Clock14MHz(Clock14MHz), 
            .ButtonUpFiltered(ButtonUpFiltered), .n386(n386), .ButtonUp_c(ButtonUp_c), 
            .n213(n213)) /* synthesis syn_module_defined=1 */ ;   // d:/lattice/kurs06/impl1/source/top.v(22[4] 27[3])
    VLO i1 (.Z(GND_net));
    Counter Counter0 (.n412(n412), .n411(n411), .CountValue({CountValue}), 
            .n4(n4), .Clock14MHz(Clock14MHz), .\Value_3__N_23[0] (Value_3__N_23[0]), 
            .\Value_3__N_23[2] (Value_3__N_23[2])) /* synthesis syn_module_defined=1 */ ;   // d:/lattice/kurs06/impl1/source/top.v(65[4] 71[3])
    TSALL TSALL_INST (.TSALL(GND_net));
    EdgeDetector UpDetector (.Clock14MHz(Clock14MHz), .ButtonUpFiltered(ButtonUpFiltered), 
            .n412(n412), .n4(n4), .\CountValue[2] (CountValue[2]), .\Value_3__N_23[2] (Value_3__N_23[2])) /* synthesis syn_module_defined=1 */ ;   // d:/lattice/kurs06/impl1/source/top.v(43[15] 49[3])
    PUR PUR_INST (.PUR(VCC_net));
    defparam PUR_INST.RST_PULSE = 1;
    
endmodule
//
// Verilog Description of module Decoder7seg
//

module Decoder7seg (CountValue, Segments_c_0, Segments_c_3, Segments_c_2, 
            Segments_c_4, Segments_c_1, Segments_c_6, Segments_c_5) /* synthesis syn_module_defined=1 */ ;
    input [3:0]CountValue;
    output Segments_c_0;
    output Segments_c_3;
    output Segments_c_2;
    output Segments_c_4;
    output Segments_c_1;
    output Segments_c_6;
    output Segments_c_5;
    
    
    LUT4 CountValue_0__bdd_4_lut (.A(CountValue[0]), .B(CountValue[3]), 
         .C(CountValue[1]), .D(CountValue[2]), .Z(Segments_c_0)) /* synthesis lut_function=(A (B (C (D)+!C !(D))+!B (C+(D)))+!A (B+(C+!(D)))) */ ;
    defparam CountValue_0__bdd_4_lut.init = 16'hf67d;
    LUT4 CountValue_3__bdd_4_lut (.A(CountValue[3]), .B(CountValue[1]), 
         .C(CountValue[0]), .D(CountValue[2]), .Z(Segments_c_3)) /* synthesis lut_function=(!(A (B (C (D)+!C !(D)))+!A (B (C (D))+!B !(C (D)+!C !(D))))) */ ;
    defparam CountValue_3__bdd_4_lut.init = 16'h3ee7;
    LUT4 Data_3__I_0_Mux_2_i15_4_lut (.A(CountValue[1]), .B(CountValue[0]), 
         .C(CountValue[3]), .D(CountValue[2]), .Z(Segments_c_2)) /* synthesis lut_function=(!(A (B (C (D))+!B (C (D)+!C !(D)))+!A !(B+!(C (D))))) */ ;   // d:/lattice/kurs06/impl1/source/decoder7seg.v(11[3] 30[10])
    defparam Data_3__I_0_Mux_2_i15_4_lut.init = 16'h4ffd;
    LUT4 CountValue_0__bdd_4_lut_375 (.A(CountValue[0]), .B(CountValue[3]), 
         .C(CountValue[1]), .D(CountValue[2]), .Z(Segments_c_4)) /* synthesis lut_function=(A (B (C+(D)))+!A (B+(C+!(D)))) */ ;
    defparam CountValue_0__bdd_4_lut_375.init = 16'hdcd5;
    LUT4 CountValue_1__bdd_4_lut (.A(CountValue[1]), .B(CountValue[3]), 
         .C(CountValue[2]), .D(CountValue[0]), .Z(Segments_c_1)) /* synthesis lut_function=(!(A (B (C+(D))+!B !((D)+!C))+!A !(B ((D)+!C)+!B !(C (D))))) */ ;
    defparam CountValue_1__bdd_4_lut.init = 16'h671f;
    LUT4 CountValue_3__bdd_4_lut_373 (.A(CountValue[3]), .B(CountValue[1]), 
         .C(CountValue[0]), .D(CountValue[2]), .Z(Segments_c_6)) /* synthesis lut_function=(A (B+(C+!(D)))+!A !(B (C (D))+!B !(D))) */ ;
    defparam CountValue_3__bdd_4_lut_373.init = 16'hbdee;
    LUT4 CountValue_1__bdd_4_lut_374 (.A(CountValue[1]), .B(CountValue[0]), 
         .C(CountValue[3]), .D(CountValue[2]), .Z(Segments_c_5)) /* synthesis lut_function=(A (B (C)+!B (C+(D)))+!A !(B (C (D)+!C !(D)))) */ ;
    defparam CountValue_1__bdd_4_lut_374.init = 16'hb7f1;
    
endmodule
//
// Verilog Description of module EdgeDetector_U0
//

module EdgeDetector_U0 (ButtonDownFiltered, \CountValue[0] , n412, \Value_3__N_23[0] , 
            n411, Clock14MHz) /* synthesis syn_module_defined=1 */ ;
    input ButtonDownFiltered;
    input \CountValue[0] ;
    input n412;
    output \Value_3__N_23[0] ;
    output n411;
    input Clock14MHz;
    
    wire Clock14MHz /* synthesis SET_AS_NETWORK=Clock14MHz, is_clock=1 */ ;   // d:/lattice/kurs06/impl1/source/top.v(13[8:18])
    
    wire Previous;
    
    LUT4 i2_2_lut_3_lut_4_lut (.A(Previous), .B(ButtonDownFiltered), .C(\CountValue[0] ), 
         .D(n412), .Z(\Value_3__N_23[0] )) /* synthesis lut_function=(!(A (C (D)+!C !(D))+!A (B (C)+!B (C (D)+!C !(D))))) */ ;   // d:/lattice/kurs06/impl1/source/edge_detector.v(17[24:62])
    defparam i2_2_lut_3_lut_4_lut.init = 16'h0fb4;
    LUT4 RisingEdge_I_0_2_lut_rep_9 (.A(Previous), .B(ButtonDownFiltered), 
         .Z(n411)) /* synthesis lut_function=(!(A+!(B))) */ ;   // d:/lattice/kurs06/impl1/source/edge_detector.v(17[24:62])
    defparam RisingEdge_I_0_2_lut_rep_9.init = 16'h4444;
    FD1S3AX Previous_13 (.D(ButtonDownFiltered), .CK(Clock14MHz), .Q(Previous)) /* synthesis lse_init_val=0, LSE_LINE_FILE_ID=3, LSE_LCOL=15, LSE_RCOL=3, LSE_LLINE=53, LSE_RLINE=59 */ ;   // d:/lattice/kurs06/impl1/source/edge_detector.v(15[7:26])
    defparam Previous_13.GSR = "ENABLED";
    
endmodule
//
// Verilog Description of module \Debouncer(FREQUENCY_MHZ=14,PERIOD_US=1)_U1 
//

module \Debouncer(FREQUENCY_MHZ=14,PERIOD_US=1)_U1  (ButtonDownFiltered, Clock14MHz, 
            n385, n203, ButtonDown_c) /* synthesis syn_module_defined=1 */ ;
    output ButtonDownFiltered;
    input Clock14MHz;
    input n385;
    output n203;
    input ButtonDown_c;
    
    wire Clock14MHz /* synthesis SET_AS_NETWORK=Clock14MHz, is_clock=1 */ ;   // d:/lattice/kurs06/impl1/source/top.v(13[8:18])
    
    wire Clock14MHz_enable_1;
    wire [3:0]Counter;   // d:/lattice/kurs06/impl1/source/debouncer.v(13[19:26])
    
    wire n189;
    wire [3:0]n21;
    
    FD1P3AX FilteredSignal_17 (.D(n385), .SP(Clock14MHz_enable_1), .CK(Clock14MHz), 
            .Q(ButtonDownFiltered)) /* synthesis LSE_LINE_FILE_ID=3, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=34, LSE_RLINE=39 */ ;   // d:/lattice/kurs06/impl1/source/debouncer.v(19[14] 26[8])
    defparam FilteredSignal_17.GSR = "ENABLED";
    FD1S3IX Counter_52__i3 (.D(n21[3]), .CK(Clock14MHz), .CD(n189), .Q(Counter[3]));   // d:/lattice/kurs06/impl1/source/debouncer.v(20[18:32])
    defparam Counter_52__i3.GSR = "ENABLED";
    LUT4 i273_2_lut_3_lut (.A(Counter[1]), .B(Counter[0]), .C(Counter[2]), 
         .Z(n21[2])) /* synthesis lut_function=(!(A (B (C)+!B !(C))+!A !(C))) */ ;   // d:/lattice/kurs06/impl1/source/debouncer.v(20[18:32])
    defparam i273_2_lut_3_lut.init = 16'h7878;
    FD1S3IX Counter_52__i0 (.D(Clock14MHz_enable_1), .CK(Clock14MHz), .CD(n189), 
            .Q(Counter[0]));   // d:/lattice/kurs06/impl1/source/debouncer.v(20[18:32])
    defparam Counter_52__i0.GSR = "ENABLED";
    FD1S3IX Counter_52__i2 (.D(n21[2]), .CK(Clock14MHz), .CD(n189), .Q(Counter[2]));   // d:/lattice/kurs06/impl1/source/debouncer.v(20[18:32])
    defparam Counter_52__i2.GSR = "ENABLED";
    FD1S3IX Counter_52__i1 (.D(n21[1]), .CK(Clock14MHz), .CD(n189), .Q(Counter[1]));   // d:/lattice/kurs06/impl1/source/debouncer.v(20[18:32])
    defparam Counter_52__i1.GSR = "ENABLED";
    LUT4 i2_3_lut (.A(Counter[2]), .B(Counter[3]), .C(Counter[1]), .Z(n203)) /* synthesis lut_function=(A (B (C))) */ ;   // d:/lattice/kurs06/impl1/source/debouncer.v(20[18:32])
    defparam i2_3_lut.init = 16'h8080;
    LUT4 i280_3_lut_4_lut (.A(Counter[1]), .B(Counter[0]), .C(Counter[2]), 
         .D(Counter[3]), .Z(n21[3])) /* synthesis lut_function=(!(A (B (C (D)+!C !(D))+!B !(D))+!A !(D))) */ ;   // d:/lattice/kurs06/impl1/source/debouncer.v(20[18:32])
    defparam i280_3_lut_4_lut.init = 16'h7f80;
    LUT4 i171_1_lut (.A(Counter[0]), .Z(Clock14MHz_enable_1)) /* synthesis lut_function=(!(A)) */ ;   // d:/lattice/kurs06/impl1/source/debouncer.v(20[18:32])
    defparam i171_1_lut.init = 16'h5555;
    LUT4 i1_3_lut (.A(ButtonDown_c), .B(n203), .C(ButtonDownFiltered), 
         .Z(n189)) /* synthesis lut_function=(A (B+(C))+!A (B+!(C))) */ ;
    defparam i1_3_lut.init = 16'heded;
    LUT4 i266_2_lut (.A(Counter[1]), .B(Counter[0]), .Z(n21[1])) /* synthesis lut_function=(!(A (B)+!A !(B))) */ ;   // d:/lattice/kurs06/impl1/source/debouncer.v(20[18:32])
    defparam i266_2_lut.init = 16'h6666;
    
endmodule
//
// Verilog Description of module \Debouncer(FREQUENCY_MHZ=14,PERIOD_US=1) 
//

module \Debouncer(FREQUENCY_MHZ=14,PERIOD_US=1)  (Clock14MHz, ButtonUpFiltered, 
            n386, ButtonUp_c, n213) /* synthesis syn_module_defined=1 */ ;
    input Clock14MHz;
    output ButtonUpFiltered;
    input n386;
    input ButtonUp_c;
    output n213;
    
    wire Clock14MHz /* synthesis SET_AS_NETWORK=Clock14MHz, is_clock=1 */ ;   // d:/lattice/kurs06/impl1/source/top.v(13[8:18])
    wire [3:0]Counter;   // d:/lattice/kurs06/impl1/source/debouncer.v(13[19:26])
    wire [3:0]n21;
    
    wire n187, Clock14MHz_enable_2;
    
    LUT4 i237_2_lut (.A(Counter[1]), .B(Counter[0]), .Z(n21[1])) /* synthesis lut_function=(!(A (B)+!A !(B))) */ ;   // d:/lattice/kurs06/impl1/source/debouncer.v(20[18:32])
    defparam i237_2_lut.init = 16'h6666;
    FD1S3IX Counter_50__i2 (.D(n21[2]), .CK(Clock14MHz), .CD(n187), .Q(Counter[2]));   // d:/lattice/kurs06/impl1/source/debouncer.v(20[18:32])
    defparam Counter_50__i2.GSR = "ENABLED";
    LUT4 i182_1_lut (.A(Counter[0]), .Z(Clock14MHz_enable_2)) /* synthesis lut_function=(!(A)) */ ;   // d:/lattice/kurs06/impl1/source/debouncer.v(20[18:32])
    defparam i182_1_lut.init = 16'h5555;
    FD1S3IX Counter_50__i1 (.D(n21[1]), .CK(Clock14MHz), .CD(n187), .Q(Counter[1]));   // d:/lattice/kurs06/impl1/source/debouncer.v(20[18:32])
    defparam Counter_50__i1.GSR = "ENABLED";
    FD1P3AX FilteredSignal_17 (.D(n386), .SP(Clock14MHz_enable_2), .CK(Clock14MHz), 
            .Q(ButtonUpFiltered)) /* synthesis LSE_LINE_FILE_ID=3, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=22, LSE_RLINE=27 */ ;   // d:/lattice/kurs06/impl1/source/debouncer.v(19[14] 26[8])
    defparam FilteredSignal_17.GSR = "ENABLED";
    FD1S3IX Counter_50__i0 (.D(Clock14MHz_enable_2), .CK(Clock14MHz), .CD(n187), 
            .Q(Counter[0]));   // d:/lattice/kurs06/impl1/source/debouncer.v(20[18:32])
    defparam Counter_50__i0.GSR = "ENABLED";
    FD1S3IX Counter_50__i3 (.D(n21[3]), .CK(Clock14MHz), .CD(n187), .Q(Counter[3]));   // d:/lattice/kurs06/impl1/source/debouncer.v(20[18:32])
    defparam Counter_50__i3.GSR = "ENABLED";
    LUT4 i244_2_lut_3_lut (.A(Counter[1]), .B(Counter[0]), .C(Counter[2]), 
         .Z(n21[2])) /* synthesis lut_function=(!(A (B (C)+!B !(C))+!A !(C))) */ ;   // d:/lattice/kurs06/impl1/source/debouncer.v(20[18:32])
    defparam i244_2_lut_3_lut.init = 16'h7878;
    LUT4 i251_3_lut_4_lut (.A(Counter[1]), .B(Counter[0]), .C(Counter[2]), 
         .D(Counter[3]), .Z(n21[3])) /* synthesis lut_function=(!(A (B (C (D)+!C !(D))+!B !(D))+!A !(D))) */ ;   // d:/lattice/kurs06/impl1/source/debouncer.v(20[18:32])
    defparam i251_3_lut_4_lut.init = 16'h7f80;
    LUT4 i1_3_lut (.A(ButtonUp_c), .B(n213), .C(ButtonUpFiltered), .Z(n187)) /* synthesis lut_function=(A (B+(C))+!A (B+!(C))) */ ;
    defparam i1_3_lut.init = 16'heded;
    LUT4 i2_3_lut (.A(Counter[3]), .B(Counter[2]), .C(Counter[1]), .Z(n213)) /* synthesis lut_function=(A (B (C))) */ ;   // d:/lattice/kurs06/impl1/source/debouncer.v(20[18:32])
    defparam i2_3_lut.init = 16'h8080;
    
endmodule
//
// Verilog Description of module Counter
//

module Counter (n412, n411, CountValue, n4, Clock14MHz, \Value_3__N_23[0] , 
            \Value_3__N_23[2] ) /* synthesis syn_module_defined=1 */ ;
    input n412;
    input n411;
    output [3:0]CountValue;
    output n4;
    input Clock14MHz;
    input \Value_3__N_23[0] ;
    input \Value_3__N_23[2] ;
    
    wire Clock14MHz /* synthesis SET_AS_NETWORK=Clock14MHz, is_clock=1 */ ;   // d:/lattice/kurs06/impl1/source/top.v(13[8:18])
    wire [3:0]Value_3__N_23;
    
    LUT4 i2_4_lut_4_lut (.A(n412), .B(n411), .C(CountValue[0]), .D(CountValue[1]), 
         .Z(Value_3__N_23[1])) /* synthesis lut_function=(!(A (C (D)+!C !(D))+!A !(B (C (D)+!C !(D))+!B (D)))) */ ;
    defparam i2_4_lut_4_lut.init = 16'h5ba4;
    LUT4 i70_4_lut (.A(CountValue[1]), .B(n412), .C(n411), .D(CountValue[0]), 
         .Z(n4)) /* synthesis lut_function=(A ((D)+!B)+!A !(B+!((D)+!C))) */ ;   // d:/lattice/kurs06/impl1/source/counter.v(16[8] 17[26])
    defparam i70_4_lut.init = 16'hbb23;
    FD1S3AX Value_i0 (.D(\Value_3__N_23[0] ), .CK(Clock14MHz), .Q(CountValue[0])) /* synthesis LSE_LINE_FILE_ID=3, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=65, LSE_RLINE=71 */ ;   // d:/lattice/kurs06/impl1/source/counter.v(14[8] 17[26])
    defparam Value_i0.GSR = "ENABLED";
    FD1S3AX Value_i3 (.D(Value_3__N_23[3]), .CK(Clock14MHz), .Q(CountValue[3])) /* synthesis LSE_LINE_FILE_ID=3, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=65, LSE_RLINE=71 */ ;   // d:/lattice/kurs06/impl1/source/counter.v(14[8] 17[26])
    defparam Value_i3.GSR = "ENABLED";
    FD1S3AX Value_i2 (.D(\Value_3__N_23[2] ), .CK(Clock14MHz), .Q(CountValue[2])) /* synthesis LSE_LINE_FILE_ID=3, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=65, LSE_RLINE=71 */ ;   // d:/lattice/kurs06/impl1/source/counter.v(14[8] 17[26])
    defparam Value_i2.GSR = "ENABLED";
    FD1S3AX Value_i1 (.D(Value_3__N_23[1]), .CK(Clock14MHz), .Q(CountValue[1])) /* synthesis LSE_LINE_FILE_ID=3, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=65, LSE_RLINE=71 */ ;   // d:/lattice/kurs06/impl1/source/counter.v(14[8] 17[26])
    defparam Value_i1.GSR = "ENABLED";
    LUT4 i2_4_lut (.A(CountValue[3]), .B(CountValue[2]), .C(n412), .D(n4), 
         .Z(Value_3__N_23[3])) /* synthesis lut_function=(!(A (B (C (D))+!B !(C+(D)))+!A !(B (C (D))+!B !(C+(D))))) */ ;
    defparam i2_4_lut.init = 16'h6aa9;
    
endmodule
//
// Verilog Description of module TSALL
// module not written out since it is a black-box. 
//

//
// Verilog Description of module EdgeDetector
//

module EdgeDetector (Clock14MHz, ButtonUpFiltered, n412, n4, \CountValue[2] , 
            \Value_3__N_23[2] ) /* synthesis syn_module_defined=1 */ ;
    input Clock14MHz;
    input ButtonUpFiltered;
    output n412;
    input n4;
    input \CountValue[2] ;
    output \Value_3__N_23[2] ;
    
    wire Clock14MHz /* synthesis SET_AS_NETWORK=Clock14MHz, is_clock=1 */ ;   // d:/lattice/kurs06/impl1/source/top.v(13[8:18])
    
    wire Previous;
    
    FD1S3AX Previous_13 (.D(ButtonUpFiltered), .CK(Clock14MHz), .Q(Previous)) /* synthesis lse_init_val=0, LSE_LINE_FILE_ID=3, LSE_LCOL=15, LSE_RCOL=3, LSE_LLINE=43, LSE_RLINE=49 */ ;   // d:/lattice/kurs06/impl1/source/edge_detector.v(15[7:26])
    defparam Previous_13.GSR = "ENABLED";
    LUT4 RisingEdge_I_0_2_lut_rep_10 (.A(Previous), .B(ButtonUpFiltered), 
         .Z(n412)) /* synthesis lut_function=(!(A+!(B))) */ ;   // d:/lattice/kurs06/impl1/source/edge_detector.v(17[24:62])
    defparam RisingEdge_I_0_2_lut_rep_10.init = 16'h4444;
    LUT4 i2_3_lut_4_lut (.A(Previous), .B(ButtonUpFiltered), .C(n4), .D(\CountValue[2] ), 
         .Z(\Value_3__N_23[2] )) /* synthesis lut_function=(A (C (D)+!C !(D))+!A !(B (C (D)+!C !(D))+!B !(C (D)+!C !(D)))) */ ;   // d:/lattice/kurs06/impl1/source/edge_detector.v(17[24:62])
    defparam i2_3_lut_4_lut.init = 16'hb44b;
    
endmodule
//
// Verilog Description of module PUR
// module not written out since it is a black-box. 
//

/* Verilog netlist generated by SCUBA Diamond (64-bit) 3.12.1.454 */
/* Module Version: 6.5 */
/* D:/Lattice/diamond/3.12/ispfpga/bin/nt64/scuba -w -bus_exp 7 -bb -arch xo2c00 -type bram -wp 10 -rp 0011 -data_width 1 -num_rows 4 -rdata_width 1 -read_reg1 outreg -gsr DISABLED -reset_rel async -memformat bin -cascade -1 -n pmi_ram_dpXbnonesadr1241241140333e -pmi -lang verilog  */
/* Sat Jan 14 15:41:06 2023 */


`timescale 1 ns / 1 ps
module pmi_ram_dpXbnonesadr1241241140333e (WrAddress, RdAddress, Data, 
    WE, RdClock, RdClockEn, Reset, WrClock, WrClockEn, Q)/* synthesis NGD_DRC_MASK=1 */;
    input wire [1:0] WrAddress;
    input wire [1:0] RdAddress;
    input wire [0:0] Data;
    input wire WE;
    input wire RdClock;
    input wire RdClockEn;
    input wire Reset;
    input wire WrClock;
    input wire WrClockEn;
    output wire [0:0] Q;

    wire scuba_vhi;
    wire scuba_vlo;

    VHI scuba_vhi_inst (.Z(scuba_vhi));

    VLO scuba_vlo_inst (.Z(scuba_vlo));

    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.INIT_DATA = "STATIC" ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.ASYNC_RESET_RELEASE = "ASYNC" ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.CSDECODE_B = "0b000" ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.CSDECODE_A = "0b000" ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.WRITEMODE_B = "NORMAL" ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.WRITEMODE_A = "NORMAL" ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.GSR = "ENABLED" ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.RESETMODE = "ASYNC" ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.REGMODE_B = "OUTREG" ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.REGMODE_A = "OUTREG" ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.DATA_WIDTH_B = 1 ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.DATA_WIDTH_A = 1 ;
    DP8KC pmi_ram_dpXbnonesadr1241241140333e_0_0_0 (.DIA8(scuba_vlo), .DIA7(scuba_vlo), 
        .DIA6(scuba_vlo), .DIA5(scuba_vlo), .DIA4(scuba_vlo), .DIA3(scuba_vlo), 
        .DIA2(scuba_vlo), .DIA1(Data[0]), .DIA0(scuba_vlo), .ADA12(scuba_vlo), 
        .ADA11(scuba_vlo), .ADA10(scuba_vlo), .ADA9(scuba_vlo), .ADA8(scuba_vlo), 
        .ADA7(scuba_vlo), .ADA6(scuba_vlo), .ADA5(scuba_vlo), .ADA4(scuba_vlo), 
        .ADA3(scuba_vlo), .ADA2(scuba_vlo), .ADA1(WrAddress[1]), .ADA0(WrAddress[0]), 
        .CEA(WrClockEn), .OCEA(WrClockEn), .CLKA(WrClock), .WEA(WE), .CSA2(scuba_vlo), 
        .CSA1(scuba_vlo), .CSA0(scuba_vlo), .RSTA(Reset), .DIB8(scuba_vlo), 
        .DIB7(scuba_vlo), .DIB6(scuba_vlo), .DIB5(scuba_vlo), .DIB4(scuba_vlo), 
        .DIB3(scuba_vlo), .DIB2(scuba_vlo), .DIB1(scuba_vlo), .DIB0(scuba_vlo), 
        .ADB12(scuba_vlo), .ADB11(scuba_vlo), .ADB10(scuba_vlo), .ADB9(scuba_vlo), 
        .ADB8(scuba_vlo), .ADB7(scuba_vlo), .ADB6(scuba_vlo), .ADB5(scuba_vlo), 
        .ADB4(scuba_vlo), .ADB3(scuba_vlo), .ADB2(scuba_vlo), .ADB1(RdAddress[1]), 
        .ADB0(RdAddress[0]), .CEB(RdClockEn), .OCEB(RdClockEn), .CLKB(RdClock), 
        .WEB(scuba_vlo), .CSB2(scuba_vlo), .CSB1(scuba_vlo), .CSB0(scuba_vlo), 
        .RSTB(Reset), .DOA8(), .DOA7(), .DOA6(), .DOA5(), .DOA4(), .DOA3(), 
        .DOA2(), .DOA1(), .DOA0(), .DOB8(), .DOB7(), .DOB6(), .DOB5(), .DOB4(), 
        .DOB3(), .DOB2(), .DOB1(), .DOB0(Q[0]))
             /* synthesis MEM_LPC_FILE="pmi_ram_dpXbnonesadr1241241140333e__PMIP__4__1__1B" */
             /* synthesis MEM_INIT_FILE="" */;



    // exemplar begin
    // exemplar attribute pmi_ram_dpXbnonesadr1241241140333e_0_0_0 MEM_LPC_FILE pmi_ram_dpXbnonesadr1241241140333e__PMIP__4__1__1B
    // exemplar attribute pmi_ram_dpXbnonesadr1241241140333e_0_0_0 MEM_INIT_FILE 
    // exemplar end

endmodule
/* Verilog netlist generated by SCUBA Diamond (64-bit) 3.12.1.454 */
/* Module Version: 3.9 */
/* D:/Lattice/diamond/3.12/ispfpga/bin/nt64/scuba -w -bus_exp 7 -bb -arch xo2c00 -type sdpram -num_rows 8 -data_width 8 -pipe_final_output -memformat bin -n pmi_distributed_dpramXbnoner8388b8d44b -pmi -lang verilog  */
/* Sat Jan 14 15:41:06 2023 */


`timescale 1 ns / 1 ps
module pmi_distributed_dpramXbnoner8388b8d44b (WrAddress, Data, WrClock, 
    WE, WrClockEn, RdAddress, RdClock, RdClockEn, Reset, Q)/* synthesis NGD_DRC_MASK=1 */;
    input wire [2:0] WrAddress;
    input wire [7:0] Data;
    input wire WrClock;
    input wire WE;
    input wire WrClockEn;
    input wire [2:0] RdAddress;
    input wire RdClock;
    input wire RdClockEn;
    input wire Reset;
    output wire [7:0] Q;

    wire dataout7_ffin;
    wire dataout6_ffin;
    wire dataout5_ffin;
    wire dataout4_ffin;
    wire dataout3_ffin;
    wire dataout2_ffin;
    wire dataout1_ffin;
    wire dataout0_ffin;
    wire dec0_wre3;
    wire scuba_vhi;

    defparam LUT4_0.initval =  16'h8000 ;
    ROM16X1A LUT4_0 (.AD3(WE), .AD2(WrClockEn), .AD1(scuba_vhi), .AD0(scuba_vhi), 
        .DO0(dec0_wre3));

    FD1P3DX FF_7 (.D(dataout7_ffin), .SP(RdClockEn), .CK(RdClock), .CD(Reset), 
        .Q(Q[7]))
             /* synthesis GSR="ENABLED" */;

    FD1P3DX FF_6 (.D(dataout6_ffin), .SP(RdClockEn), .CK(RdClock), .CD(Reset), 
        .Q(Q[6]))
             /* synthesis GSR="ENABLED" */;

    FD1P3DX FF_5 (.D(dataout5_ffin), .SP(RdClockEn), .CK(RdClock), .CD(Reset), 
        .Q(Q[5]))
             /* synthesis GSR="ENABLED" */;

    FD1P3DX FF_4 (.D(dataout4_ffin), .SP(RdClockEn), .CK(RdClock), .CD(Reset), 
        .Q(Q[4]))
             /* synthesis GSR="ENABLED" */;

    FD1P3DX FF_3 (.D(dataout3_ffin), .SP(RdClockEn), .CK(RdClock), .CD(Reset), 
        .Q(Q[3]))
             /* synthesis GSR="ENABLED" */;

    FD1P3DX FF_2 (.D(dataout2_ffin), .SP(RdClockEn), .CK(RdClock), .CD(Reset), 
        .Q(Q[2]))
             /* synthesis GSR="ENABLED" */;

    FD1P3DX FF_1 (.D(dataout1_ffin), .SP(RdClockEn), .CK(RdClock), .CD(Reset), 
        .Q(Q[1]))
             /* synthesis GSR="ENABLED" */;

    FD1P3DX FF_0 (.D(dataout0_ffin), .SP(RdClockEn), .CK(RdClock), .CD(Reset), 
        .Q(Q[0]))
             /* synthesis GSR="ENABLED" */;

    defparam mem_0_0.initval = "0x0000000000000000" ;
    DPR16X4C mem_0_0 (.DI0(Data[4]), .DI1(Data[5]), .DI2(Data[6]), .DI3(Data[7]), 
        .WCK(WrClock), .WRE(dec0_wre3), .RAD0(RdAddress[0]), .RAD1(RdAddress[1]), 
        .RAD2(RdAddress[2]), .RAD3(scuba_vhi), .WAD0(WrAddress[0]), .WAD1(WrAddress[1]), 
        .WAD2(WrAddress[2]), .WAD3(scuba_vhi), .DO0(dataout4_ffin), .DO1(dataout5_ffin), 
        .DO2(dataout6_ffin), .DO3(dataout7_ffin))
             /* synthesis MEM_INIT_FILE="(0-7)(0-3)" */
             /* synthesis MEM_LPC_FILE="pmi_distributed_dpramXbnoner8388b8d44b__PMI__8__8__8B" */
             /* synthesis COMP="mem_0_0" */;

    VHI scuba_vhi_inst (.Z(scuba_vhi));

    defparam mem_0_1.initval = "0x0000000000000000" ;
    DPR16X4C mem_0_1 (.DI0(Data[0]), .DI1(Data[1]), .DI2(Data[2]), .DI3(Data[3]), 
        .WCK(WrClock), .WRE(dec0_wre3), .RAD0(RdAddress[0]), .RAD1(RdAddress[1]), 
        .RAD2(RdAddress[2]), .RAD3(scuba_vhi), .WAD0(WrAddress[0]), .WAD1(WrAddress[1]), 
        .WAD2(WrAddress[2]), .WAD3(scuba_vhi), .DO0(dataout0_ffin), .DO1(dataout1_ffin), 
        .DO2(dataout2_ffin), .DO3(dataout3_ffin))
             /* synthesis MEM_INIT_FILE="(0-7)(4-7)" */
             /* synthesis MEM_LPC_FILE="pmi_distributed_dpramXbnoner8388b8d44b__PMI__8__8__8B" */
             /* synthesis COMP="mem_0_1" */;



    // exemplar begin
    // exemplar attribute FF_7 GSR ENABLED
    // exemplar attribute FF_6 GSR ENABLED
    // exemplar attribute FF_5 GSR ENABLED
    // exemplar attribute FF_4 GSR ENABLED
    // exemplar attribute FF_3 GSR ENABLED
    // exemplar attribute FF_2 GSR ENABLED
    // exemplar attribute FF_1 GSR ENABLED
    // exemplar attribute FF_0 GSR ENABLED
    // exemplar attribute mem_0_0 MEM_INIT_FILE (0-7)(0-3)
    // exemplar attribute mem_0_0 MEM_LPC_FILE pmi_distributed_dpramXbnoner8388b8d44b__PMI__8__8__8B
    // exemplar attribute mem_0_0 COMP mem_0_0
    // exemplar attribute mem_0_1 MEM_INIT_FILE (0-7)(4-7)
    // exemplar attribute mem_0_1 MEM_LPC_FILE pmi_distributed_dpramXbnoner8388b8d44b__PMI__8__8__8B
    // exemplar attribute mem_0_1 COMP mem_0_1
    // exemplar end

endmodule
/* Verilog netlist generated by SCUBA Diamond (64-bit) 3.12.1.454 */
/* Module Version: 6.5 */
/* D:/Lattice/diamond/3.12/ispfpga/bin/nt64/scuba -w -bus_exp 7 -bb -arch xo2c00 -type bram -wp 10 -rp 0011 -data_width 18 -num_rows 256 -rdata_width 18 -read_reg1 outreg -gsr DISABLED -reset_rel async -memformat bin -cascade -1 -n pmi_ram_dpXbnonesadr18825618825611acaa0e -pmi -lang verilog  */
/* Sat Jan 14 15:41:06 2023 */


`timescale 1 ns / 1 ps
module pmi_ram_dpXbnonesadr18825618825611acaa0e (WrAddress, RdAddress, 
    Data, WE, RdClock, RdClockEn, Reset, WrClock, WrClockEn, Q)/* synthesis NGD_DRC_MASK=1 */;
    input wire [7:0] WrAddress;
    input wire [7:0] RdAddress;
    input wire [17:0] Data;
    input wire WE;
    input wire RdClock;
    input wire RdClockEn;
    input wire Reset;
    input wire WrClock;
    input wire WrClockEn;
    output wire [17:0] Q;

    wire scuba_vhi;
    wire scuba_vlo;

    VHI scuba_vhi_inst (.Z(scuba_vhi));

    VLO scuba_vlo_inst (.Z(scuba_vlo));

    defparam pmi_ram_dpXbnonesadr18825618825611acaa0e_0_0_0.INIT_DATA = "STATIC" ;
    defparam pmi_ram_dpXbnonesadr18825618825611acaa0e_0_0_0.ASYNC_RESET_RELEASE = "ASYNC" ;
    defparam pmi_ram_dpXbnonesadr18825618825611acaa0e_0_0_0.CSDECODE_R = "0b000" ;
    defparam pmi_ram_dpXbnonesadr18825618825611acaa0e_0_0_0.CSDECODE_W = "0b001" ;
    defparam pmi_ram_dpXbnonesadr18825618825611acaa0e_0_0_0.GSR = "ENABLED" ;
    defparam pmi_ram_dpXbnonesadr18825618825611acaa0e_0_0_0.RESETMODE = "ASYNC" ;
    defparam pmi_ram_dpXbnonesadr18825618825611acaa0e_0_0_0.REGMODE = "OUTREG" ;
    defparam pmi_ram_dpXbnonesadr18825618825611acaa0e_0_0_0.DATA_WIDTH_R = 18 ;
    defparam pmi_ram_dpXbnonesadr18825618825611acaa0e_0_0_0.DATA_WIDTH_W = 18 ;
    PDPW8KC pmi_ram_dpXbnonesadr18825618825611acaa0e_0_0_0 (.DI17(Data[17]), 
        .DI16(Data[16]), .DI15(Data[15]), .DI14(Data[14]), .DI13(Data[13]), 
        .DI12(Data[12]), .DI11(Data[11]), .DI10(Data[10]), .DI9(Data[9]), 
        .DI8(Data[8]), .DI7(Data[7]), .DI6(Data[6]), .DI5(Data[5]), .DI4(Data[4]), 
        .DI3(Data[3]), .DI2(Data[2]), .DI1(Data[1]), .DI0(Data[0]), .ADW8(scuba_vlo), 
        .ADW7(WrAddress[7]), .ADW6(WrAddress[6]), .ADW5(WrAddress[5]), .ADW4(WrAddress[4]), 
        .ADW3(WrAddress[3]), .ADW2(WrAddress[2]), .ADW1(WrAddress[1]), .ADW0(WrAddress[0]), 
        .BE1(scuba_vhi), .BE0(scuba_vhi), .CEW(WrClockEn), .CLKW(WrClock), 
        .CSW2(scuba_vlo), .CSW1(scuba_vlo), .CSW0(WE), .ADR12(scuba_vlo), 
        .ADR11(RdAddress[7]), .ADR10(RdAddress[6]), .ADR9(RdAddress[5]), 
        .ADR8(RdAddress[4]), .ADR7(RdAddress[3]), .ADR6(RdAddress[2]), .ADR5(RdAddress[1]), 
        .ADR4(RdAddress[0]), .ADR3(scuba_vlo), .ADR2(scuba_vlo), .ADR1(scuba_vlo), 
        .ADR0(scuba_vlo), .CER(RdClockEn), .OCER(RdClockEn), .CLKR(RdClock), 
        .CSR2(scuba_vlo), .CSR1(scuba_vlo), .CSR0(scuba_vlo), .RST(Reset), 
        .DO17(Q[8]), .DO16(Q[7]), .DO15(Q[6]), .DO14(Q[5]), .DO13(Q[4]), 
        .DO12(Q[3]), .DO11(Q[2]), .DO10(Q[1]), .DO9(Q[0]), .DO8(Q[17]), 
        .DO7(Q[16]), .DO6(Q[15]), .DO5(Q[14]), .DO4(Q[13]), .DO3(Q[12]), 
        .DO2(Q[11]), .DO1(Q[10]), .DO0(Q[9]))
             /* synthesis MEM_LPC_FILE="pmi_ram_dpXbnonesadr18825618825611acaa0e__PMIP__256__18__18B" */
             /* synthesis MEM_INIT_FILE="" */;



    // exemplar begin
    // exemplar attribute pmi_ram_dpXbnonesadr18825618825611acaa0e_0_0_0 MEM_LPC_FILE pmi_ram_dpXbnonesadr18825618825611acaa0e__PMIP__256__18__18B
    // exemplar attribute pmi_ram_dpXbnonesadr18825618825611acaa0e_0_0_0 MEM_INIT_FILE 
    // exemplar end

endmodule
/* Verilog netlist generated by SCUBA Diamond (64-bit) 3.12.1.454 */
/* Module Version: 6.5 */
/* D:/Lattice/diamond/3.12/ispfpga/bin/nt64/scuba -w -bus_exp 7 -bb -arch xo2c00 -type bram -wp 10 -rp 0011 -data_width 1 -num_rows 4 -rdata_width 1 -read_reg1 outreg -gsr DISABLED -reset_rel async -memformat bin -cascade -1 -n pmi_ram_dpXbnonesadr1241241140333e -pmi -lang verilog  */
/* Sat Jan 14 16:26:20 2023 */


`timescale 1 ns / 1 ps
module pmi_ram_dpXbnonesadr1241241140333e (WrAddress, RdAddress, Data, 
    WE, RdClock, RdClockEn, Reset, WrClock, WrClockEn, Q)/* synthesis NGD_DRC_MASK=1 */;
    input wire [1:0] WrAddress;
    input wire [1:0] RdAddress;
    input wire [0:0] Data;
    input wire WE;
    input wire RdClock;
    input wire RdClockEn;
    input wire Reset;
    input wire WrClock;
    input wire WrClockEn;
    output wire [0:0] Q;

    wire scuba_vhi;
    wire scuba_vlo;

    VHI scuba_vhi_inst (.Z(scuba_vhi));

    VLO scuba_vlo_inst (.Z(scuba_vlo));

    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.INIT_DATA = "STATIC" ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.ASYNC_RESET_RELEASE = "ASYNC" ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.CSDECODE_B = "0b000" ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.CSDECODE_A = "0b000" ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.WRITEMODE_B = "NORMAL" ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.WRITEMODE_A = "NORMAL" ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.GSR = "ENABLED" ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.RESETMODE = "ASYNC" ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.REGMODE_B = "OUTREG" ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.REGMODE_A = "OUTREG" ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.DATA_WIDTH_B = 1 ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.DATA_WIDTH_A = 1 ;
    DP8KC pmi_ram_dpXbnonesadr1241241140333e_0_0_0 (.DIA8(scuba_vlo), .DIA7(scuba_vlo), 
        .DIA6(scuba_vlo), .DIA5(scuba_vlo), .DIA4(scuba_vlo), .DIA3(scuba_vlo), 
        .DIA2(scuba_vlo), .DIA1(Data[0]), .DIA0(scuba_vlo), .ADA12(scuba_vlo), 
        .ADA11(scuba_vlo), .ADA10(scuba_vlo), .ADA9(scuba_vlo), .ADA8(scuba_vlo), 
        .ADA7(scuba_vlo), .ADA6(scuba_vlo), .ADA5(scuba_vlo), .ADA4(scuba_vlo), 
        .ADA3(scuba_vlo), .ADA2(scuba_vlo), .ADA1(WrAddress[1]), .ADA0(WrAddress[0]), 
        .CEA(WrClockEn), .OCEA(WrClockEn), .CLKA(WrClock), .WEA(WE), .CSA2(scuba_vlo), 
        .CSA1(scuba_vlo), .CSA0(scuba_vlo), .RSTA(Reset), .DIB8(scuba_vlo), 
        .DIB7(scuba_vlo), .DIB6(scuba_vlo), .DIB5(scuba_vlo), .DIB4(scuba_vlo), 
        .DIB3(scuba_vlo), .DIB2(scuba_vlo), .DIB1(scuba_vlo), .DIB0(scuba_vlo), 
        .ADB12(scuba_vlo), .ADB11(scuba_vlo), .ADB10(scuba_vlo), .ADB9(scuba_vlo), 
        .ADB8(scuba_vlo), .ADB7(scuba_vlo), .ADB6(scuba_vlo), .ADB5(scuba_vlo), 
        .ADB4(scuba_vlo), .ADB3(scuba_vlo), .ADB2(scuba_vlo), .ADB1(RdAddress[1]), 
        .ADB0(RdAddress[0]), .CEB(RdClockEn), .OCEB(RdClockEn), .CLKB(RdClock), 
        .WEB(scuba_vlo), .CSB2(scuba_vlo), .CSB1(scuba_vlo), .CSB0(scuba_vlo), 
        .RSTB(Reset), .DOA8(), .DOA7(), .DOA6(), .DOA5(), .DOA4(), .DOA3(), 
        .DOA2(), .DOA1(), .DOA0(), .DOB8(), .DOB7(), .DOB6(), .DOB5(), .DOB4(), 
        .DOB3(), .DOB2(), .DOB1(), .DOB0(Q[0]))
             /* synthesis MEM_LPC_FILE="pmi_ram_dpXbnonesadr1241241140333e__PMIP__4__1__1B" */
             /* synthesis MEM_INIT_FILE="" */;



    // exemplar begin
    // exemplar attribute pmi_ram_dpXbnonesadr1241241140333e_0_0_0 MEM_LPC_FILE pmi_ram_dpXbnonesadr1241241140333e__PMIP__4__1__1B
    // exemplar attribute pmi_ram_dpXbnonesadr1241241140333e_0_0_0 MEM_INIT_FILE 
    // exemplar end

endmodule
/* Verilog netlist generated by SCUBA Diamond (64-bit) 3.12.1.454 */
/* Module Version: 3.9 */
/* D:/Lattice/diamond/3.12/ispfpga/bin/nt64/scuba -w -bus_exp 7 -bb -arch xo2c00 -type sdpram -num_rows 8 -data_width 8 -pipe_final_output -memformat bin -n pmi_distributed_dpramXbnoner8388b8d44b -pmi -lang verilog  */
/* Sat Jan 14 16:26:20 2023 */


`timescale 1 ns / 1 ps
module pmi_distributed_dpramXbnoner8388b8d44b (WrAddress, Data, WrClock, 
    WE, WrClockEn, RdAddress, RdClock, RdClockEn, Reset, Q)/* synthesis NGD_DRC_MASK=1 */;
    input wire [2:0] WrAddress;
    input wire [7:0] Data;
    input wire WrClock;
    input wire WE;
    input wire WrClockEn;
    input wire [2:0] RdAddress;
    input wire RdClock;
    input wire RdClockEn;
    input wire Reset;
    output wire [7:0] Q;

    wire dataout7_ffin;
    wire dataout6_ffin;
    wire dataout5_ffin;
    wire dataout4_ffin;
    wire dataout3_ffin;
    wire dataout2_ffin;
    wire dataout1_ffin;
    wire dataout0_ffin;
    wire dec0_wre3;
    wire scuba_vhi;

    defparam LUT4_0.initval =  16'h8000 ;
    ROM16X1A LUT4_0 (.AD3(WE), .AD2(WrClockEn), .AD1(scuba_vhi), .AD0(scuba_vhi), 
        .DO0(dec0_wre3));

    FD1P3DX FF_7 (.D(dataout7_ffin), .SP(RdClockEn), .CK(RdClock), .CD(Reset), 
        .Q(Q[7]))
             /* synthesis GSR="ENABLED" */;

    FD1P3DX FF_6 (.D(dataout6_ffin), .SP(RdClockEn), .CK(RdClock), .CD(Reset), 
        .Q(Q[6]))
             /* synthesis GSR="ENABLED" */;

    FD1P3DX FF_5 (.D(dataout5_ffin), .SP(RdClockEn), .CK(RdClock), .CD(Reset), 
        .Q(Q[5]))
             /* synthesis GSR="ENABLED" */;

    FD1P3DX FF_4 (.D(dataout4_ffin), .SP(RdClockEn), .CK(RdClock), .CD(Reset), 
        .Q(Q[4]))
             /* synthesis GSR="ENABLED" */;

    FD1P3DX FF_3 (.D(dataout3_ffin), .SP(RdClockEn), .CK(RdClock), .CD(Reset), 
        .Q(Q[3]))
             /* synthesis GSR="ENABLED" */;

    FD1P3DX FF_2 (.D(dataout2_ffin), .SP(RdClockEn), .CK(RdClock), .CD(Reset), 
        .Q(Q[2]))
             /* synthesis GSR="ENABLED" */;

    FD1P3DX FF_1 (.D(dataout1_ffin), .SP(RdClockEn), .CK(RdClock), .CD(Reset), 
        .Q(Q[1]))
             /* synthesis GSR="ENABLED" */;

    FD1P3DX FF_0 (.D(dataout0_ffin), .SP(RdClockEn), .CK(RdClock), .CD(Reset), 
        .Q(Q[0]))
             /* synthesis GSR="ENABLED" */;

    defparam mem_0_0.initval = "0x0000000000000000" ;
    DPR16X4C mem_0_0 (.DI0(Data[4]), .DI1(Data[5]), .DI2(Data[6]), .DI3(Data[7]), 
        .WCK(WrClock), .WRE(dec0_wre3), .RAD0(RdAddress[0]), .RAD1(RdAddress[1]), 
        .RAD2(RdAddress[2]), .RAD3(scuba_vhi), .WAD0(WrAddress[0]), .WAD1(WrAddress[1]), 
        .WAD2(WrAddress[2]), .WAD3(scuba_vhi), .DO0(dataout4_ffin), .DO1(dataout5_ffin), 
        .DO2(dataout6_ffin), .DO3(dataout7_ffin))
             /* synthesis MEM_INIT_FILE="(0-7)(0-3)" */
             /* synthesis MEM_LPC_FILE="pmi_distributed_dpramXbnoner8388b8d44b__PMI__8__8__8B" */
             /* synthesis COMP="mem_0_0" */;

    VHI scuba_vhi_inst (.Z(scuba_vhi));

    defparam mem_0_1.initval = "0x0000000000000000" ;
    DPR16X4C mem_0_1 (.DI0(Data[0]), .DI1(Data[1]), .DI2(Data[2]), .DI3(Data[3]), 
        .WCK(WrClock), .WRE(dec0_wre3), .RAD0(RdAddress[0]), .RAD1(RdAddress[1]), 
        .RAD2(RdAddress[2]), .RAD3(scuba_vhi), .WAD0(WrAddress[0]), .WAD1(WrAddress[1]), 
        .WAD2(WrAddress[2]), .WAD3(scuba_vhi), .DO0(dataout0_ffin), .DO1(dataout1_ffin), 
        .DO2(dataout2_ffin), .DO3(dataout3_ffin))
             /* synthesis MEM_INIT_FILE="(0-7)(4-7)" */
             /* synthesis MEM_LPC_FILE="pmi_distributed_dpramXbnoner8388b8d44b__PMI__8__8__8B" */
             /* synthesis COMP="mem_0_1" */;



    // exemplar begin
    // exemplar attribute FF_7 GSR ENABLED
    // exemplar attribute FF_6 GSR ENABLED
    // exemplar attribute FF_5 GSR ENABLED
    // exemplar attribute FF_4 GSR ENABLED
    // exemplar attribute FF_3 GSR ENABLED
    // exemplar attribute FF_2 GSR ENABLED
    // exemplar attribute FF_1 GSR ENABLED
    // exemplar attribute FF_0 GSR ENABLED
    // exemplar attribute mem_0_0 MEM_INIT_FILE (0-7)(0-3)
    // exemplar attribute mem_0_0 MEM_LPC_FILE pmi_distributed_dpramXbnoner8388b8d44b__PMI__8__8__8B
    // exemplar attribute mem_0_0 COMP mem_0_0
    // exemplar attribute mem_0_1 MEM_INIT_FILE (0-7)(4-7)
    // exemplar attribute mem_0_1 MEM_LPC_FILE pmi_distributed_dpramXbnoner8388b8d44b__PMI__8__8__8B
    // exemplar attribute mem_0_1 COMP mem_0_1
    // exemplar end

endmodule
/* Verilog netlist generated by SCUBA Diamond (64-bit) 3.12.1.454 */
/* Module Version: 6.5 */
/* D:/Lattice/diamond/3.12/ispfpga/bin/nt64/scuba -w -bus_exp 7 -bb -arch xo2c00 -type bram -wp 10 -rp 0011 -data_width 18 -num_rows 256 -rdata_width 18 -read_reg1 outreg -gsr DISABLED -reset_rel async -memformat bin -cascade -1 -n pmi_ram_dpXbnonesadr18825618825611acaa0e -pmi -lang verilog  */
/* Sat Jan 14 16:26:20 2023 */


`timescale 1 ns / 1 ps
module pmi_ram_dpXbnonesadr18825618825611acaa0e (WrAddress, RdAddress, 
    Data, WE, RdClock, RdClockEn, Reset, WrClock, WrClockEn, Q)/* synthesis NGD_DRC_MASK=1 */;
    input wire [7:0] WrAddress;
    input wire [7:0] RdAddress;
    input wire [17:0] Data;
    input wire WE;
    input wire RdClock;
    input wire RdClockEn;
    input wire Reset;
    input wire WrClock;
    input wire WrClockEn;
    output wire [17:0] Q;

    wire scuba_vhi;
    wire scuba_vlo;

    VHI scuba_vhi_inst (.Z(scuba_vhi));

    VLO scuba_vlo_inst (.Z(scuba_vlo));

    defparam pmi_ram_dpXbnonesadr18825618825611acaa0e_0_0_0.INIT_DATA = "STATIC" ;
    defparam pmi_ram_dpXbnonesadr18825618825611acaa0e_0_0_0.ASYNC_RESET_RELEASE = "ASYNC" ;
    defparam pmi_ram_dpXbnonesadr18825618825611acaa0e_0_0_0.CSDECODE_R = "0b000" ;
    defparam pmi_ram_dpXbnonesadr18825618825611acaa0e_0_0_0.CSDECODE_W = "0b001" ;
    defparam pmi_ram_dpXbnonesadr18825618825611acaa0e_0_0_0.GSR = "ENABLED" ;
    defparam pmi_ram_dpXbnonesadr18825618825611acaa0e_0_0_0.RESETMODE = "ASYNC" ;
    defparam pmi_ram_dpXbnonesadr18825618825611acaa0e_0_0_0.REGMODE = "OUTREG" ;
    defparam pmi_ram_dpXbnonesadr18825618825611acaa0e_0_0_0.DATA_WIDTH_R = 18 ;
    defparam pmi_ram_dpXbnonesadr18825618825611acaa0e_0_0_0.DATA_WIDTH_W = 18 ;
    PDPW8KC pmi_ram_dpXbnonesadr18825618825611acaa0e_0_0_0 (.DI17(Data[17]), 
        .DI16(Data[16]), .DI15(Data[15]), .DI14(Data[14]), .DI13(Data[13]), 
        .DI12(Data[12]), .DI11(Data[11]), .DI10(Data[10]), .DI9(Data[9]), 
        .DI8(Data[8]), .DI7(Data[7]), .DI6(Data[6]), .DI5(Data[5]), .DI4(Data[4]), 
        .DI3(Data[3]), .DI2(Data[2]), .DI1(Data[1]), .DI0(Data[0]), .ADW8(scuba_vlo), 
        .ADW7(WrAddress[7]), .ADW6(WrAddress[6]), .ADW5(WrAddress[5]), .ADW4(WrAddress[4]), 
        .ADW3(WrAddress[3]), .ADW2(WrAddress[2]), .ADW1(WrAddress[1]), .ADW0(WrAddress[0]), 
        .BE1(scuba_vhi), .BE0(scuba_vhi), .CEW(WrClockEn), .CLKW(WrClock), 
        .CSW2(scuba_vlo), .CSW1(scuba_vlo), .CSW0(WE), .ADR12(scuba_vlo), 
        .ADR11(RdAddress[7]), .ADR10(RdAddress[6]), .ADR9(RdAddress[5]), 
        .ADR8(RdAddress[4]), .ADR7(RdAddress[3]), .ADR6(RdAddress[2]), .ADR5(RdAddress[1]), 
        .ADR4(RdAddress[0]), .ADR3(scuba_vlo), .ADR2(scuba_vlo), .ADR1(scuba_vlo), 
        .ADR0(scuba_vlo), .CER(RdClockEn), .OCER(RdClockEn), .CLKR(RdClock), 
        .CSR2(scuba_vlo), .CSR1(scuba_vlo), .CSR0(scuba_vlo), .RST(Reset), 
        .DO17(Q[8]), .DO16(Q[7]), .DO15(Q[6]), .DO14(Q[5]), .DO13(Q[4]), 
        .DO12(Q[3]), .DO11(Q[2]), .DO10(Q[1]), .DO9(Q[0]), .DO8(Q[17]), 
        .DO7(Q[16]), .DO6(Q[15]), .DO5(Q[14]), .DO4(Q[13]), .DO3(Q[12]), 
        .DO2(Q[11]), .DO1(Q[10]), .DO0(Q[9]))
             /* synthesis MEM_LPC_FILE="pmi_ram_dpXbnonesadr18825618825611acaa0e__PMIP__256__18__18B" */
             /* synthesis MEM_INIT_FILE="" */;



    // exemplar begin
    // exemplar attribute pmi_ram_dpXbnonesadr18825618825611acaa0e_0_0_0 MEM_LPC_FILE pmi_ram_dpXbnonesadr18825618825611acaa0e__PMIP__256__18__18B
    // exemplar attribute pmi_ram_dpXbnonesadr18825618825611acaa0e_0_0_0 MEM_INIT_FILE 
    // exemplar end

endmodule
/* Verilog netlist generated by SCUBA Diamond (64-bit) 3.12.1.454 */
/* Module Version: 6.5 */
/* D:/Lattice/diamond/3.12/ispfpga/bin/nt64/scuba -w -bus_exp 7 -bb -arch xo2c00 -type bram -wp 10 -rp 0011 -data_width 1 -num_rows 4 -rdata_width 1 -read_reg1 outreg -gsr DISABLED -reset_rel async -memformat bin -cascade -1 -n pmi_ram_dpXbnonesadr1241241140333e -pmi -lang verilog  */
/* Sat Jan 14 16:28:00 2023 */


`timescale 1 ns / 1 ps
module pmi_ram_dpXbnonesadr1241241140333e (WrAddress, RdAddress, Data, 
    WE, RdClock, RdClockEn, Reset, WrClock, WrClockEn, Q)/* synthesis NGD_DRC_MASK=1 */;
    input wire [1:0] WrAddress;
    input wire [1:0] RdAddress;
    input wire [0:0] Data;
    input wire WE;
    input wire RdClock;
    input wire RdClockEn;
    input wire Reset;
    input wire WrClock;
    input wire WrClockEn;
    output wire [0:0] Q;

    wire scuba_vhi;
    wire scuba_vlo;

    VHI scuba_vhi_inst (.Z(scuba_vhi));

    VLO scuba_vlo_inst (.Z(scuba_vlo));

    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.INIT_DATA = "STATIC" ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.ASYNC_RESET_RELEASE = "ASYNC" ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.CSDECODE_B = "0b000" ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.CSDECODE_A = "0b000" ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.WRITEMODE_B = "NORMAL" ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.WRITEMODE_A = "NORMAL" ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.GSR = "ENABLED" ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.RESETMODE = "ASYNC" ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.REGMODE_B = "OUTREG" ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.REGMODE_A = "OUTREG" ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.DATA_WIDTH_B = 1 ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.DATA_WIDTH_A = 1 ;
    DP8KC pmi_ram_dpXbnonesadr1241241140333e_0_0_0 (.DIA8(scuba_vlo), .DIA7(scuba_vlo), 
        .DIA6(scuba_vlo), .DIA5(scuba_vlo), .DIA4(scuba_vlo), .DIA3(scuba_vlo), 
        .DIA2(scuba_vlo), .DIA1(Data[0]), .DIA0(scuba_vlo), .ADA12(scuba_vlo), 
        .ADA11(scuba_vlo), .ADA10(scuba_vlo), .ADA9(scuba_vlo), .ADA8(scuba_vlo), 
        .ADA7(scuba_vlo), .ADA6(scuba_vlo), .ADA5(scuba_vlo), .ADA4(scuba_vlo), 
        .ADA3(scuba_vlo), .ADA2(scuba_vlo), .ADA1(WrAddress[1]), .ADA0(WrAddress[0]), 
        .CEA(WrClockEn), .OCEA(WrClockEn), .CLKA(WrClock), .WEA(WE), .CSA2(scuba_vlo), 
        .CSA1(scuba_vlo), .CSA0(scuba_vlo), .RSTA(Reset), .DIB8(scuba_vlo), 
        .DIB7(scuba_vlo), .DIB6(scuba_vlo), .DIB5(scuba_vlo), .DIB4(scuba_vlo), 
        .DIB3(scuba_vlo), .DIB2(scuba_vlo), .DIB1(scuba_vlo), .DIB0(scuba_vlo), 
        .ADB12(scuba_vlo), .ADB11(scuba_vlo), .ADB10(scuba_vlo), .ADB9(scuba_vlo), 
        .ADB8(scuba_vlo), .ADB7(scuba_vlo), .ADB6(scuba_vlo), .ADB5(scuba_vlo), 
        .ADB4(scuba_vlo), .ADB3(scuba_vlo), .ADB2(scuba_vlo), .ADB1(RdAddress[1]), 
        .ADB0(RdAddress[0]), .CEB(RdClockEn), .OCEB(RdClockEn), .CLKB(RdClock), 
        .WEB(scuba_vlo), .CSB2(scuba_vlo), .CSB1(scuba_vlo), .CSB0(scuba_vlo), 
        .RSTB(Reset), .DOA8(), .DOA7(), .DOA6(), .DOA5(), .DOA4(), .DOA3(), 
        .DOA2(), .DOA1(), .DOA0(), .DOB8(), .DOB7(), .DOB6(), .DOB5(), .DOB4(), 
        .DOB3(), .DOB2(), .DOB1(), .DOB0(Q[0]))
             /* synthesis MEM_LPC_FILE="pmi_ram_dpXbnonesadr1241241140333e__PMIP__4__1__1B" */
             /* synthesis MEM_INIT_FILE="" */;



    // exemplar begin
    // exemplar attribute pmi_ram_dpXbnonesadr1241241140333e_0_0_0 MEM_LPC_FILE pmi_ram_dpXbnonesadr1241241140333e__PMIP__4__1__1B
    // exemplar attribute pmi_ram_dpXbnonesadr1241241140333e_0_0_0 MEM_INIT_FILE 
    // exemplar end

endmodule
/* Verilog netlist generated by SCUBA Diamond (64-bit) 3.12.1.454 */
/* Module Version: 3.9 */
/* D:/Lattice/diamond/3.12/ispfpga/bin/nt64/scuba -w -bus_exp 7 -bb -arch xo2c00 -type sdpram -num_rows 4 -data_width 7 -pipe_final_output -memformat bin -n pmi_distributed_dpramXbnoner7248b8bbf2 -pmi -lang verilog  */
/* Sat Jan 14 16:28:00 2023 */


`timescale 1 ns / 1 ps
module pmi_distributed_dpramXbnoner7248b8bbf2 (WrAddress, Data, WrClock, 
    WE, WrClockEn, RdAddress, RdClock, RdClockEn, Reset, Q)/* synthesis NGD_DRC_MASK=1 */;
    input wire [1:0] WrAddress;
    input wire [6:0] Data;
    input wire WrClock;
    input wire WE;
    input wire WrClockEn;
    input wire [1:0] RdAddress;
    input wire RdClock;
    input wire RdClockEn;
    input wire Reset;
    output wire [6:0] Q;

    wire dataout6_ffin;
    wire dataout5_ffin;
    wire dataout4_ffin;
    wire dataout3_ffin;
    wire dataout2_ffin;
    wire dataout1_ffin;
    wire dataout0_ffin;
    wire dec0_wre3;
    wire scuba_vhi;

    defparam LUT4_0.initval =  16'h8000 ;
    ROM16X1A LUT4_0 (.AD3(WE), .AD2(WrClockEn), .AD1(scuba_vhi), .AD0(scuba_vhi), 
        .DO0(dec0_wre3));

    FD1P3DX FF_6 (.D(dataout6_ffin), .SP(RdClockEn), .CK(RdClock), .CD(Reset), 
        .Q(Q[6]))
             /* synthesis GSR="ENABLED" */;

    FD1P3DX FF_5 (.D(dataout5_ffin), .SP(RdClockEn), .CK(RdClock), .CD(Reset), 
        .Q(Q[5]))
             /* synthesis GSR="ENABLED" */;

    FD1P3DX FF_4 (.D(dataout4_ffin), .SP(RdClockEn), .CK(RdClock), .CD(Reset), 
        .Q(Q[4]))
             /* synthesis GSR="ENABLED" */;

    FD1P3DX FF_3 (.D(dataout3_ffin), .SP(RdClockEn), .CK(RdClock), .CD(Reset), 
        .Q(Q[3]))
             /* synthesis GSR="ENABLED" */;

    FD1P3DX FF_2 (.D(dataout2_ffin), .SP(RdClockEn), .CK(RdClock), .CD(Reset), 
        .Q(Q[2]))
             /* synthesis GSR="ENABLED" */;

    FD1P3DX FF_1 (.D(dataout1_ffin), .SP(RdClockEn), .CK(RdClock), .CD(Reset), 
        .Q(Q[1]))
             /* synthesis GSR="ENABLED" */;

    FD1P3DX FF_0 (.D(dataout0_ffin), .SP(RdClockEn), .CK(RdClock), .CD(Reset), 
        .Q(Q[0]))
             /* synthesis GSR="ENABLED" */;

    defparam mem_0_0.initval = "0x0000000000000000" ;
    DPR16X4C mem_0_0 (.DI0(Data[4]), .DI1(Data[5]), .DI2(Data[6]), .DI3(scuba_vhi), 
        .WCK(WrClock), .WRE(dec0_wre3), .RAD0(RdAddress[0]), .RAD1(RdAddress[1]), 
        .RAD2(scuba_vhi), .RAD3(scuba_vhi), .WAD0(WrAddress[0]), .WAD1(WrAddress[1]), 
        .WAD2(scuba_vhi), .WAD3(scuba_vhi), .DO0(dataout4_ffin), .DO1(dataout5_ffin), 
        .DO2(dataout6_ffin), .DO3())
             /* synthesis MEM_INIT_FILE="(0-3)(0-3)" */
             /* synthesis MEM_LPC_FILE="pmi_distributed_dpramXbnoner7248b8bbf2__PMI__4__7__7B" */
             /* synthesis COMP="mem_0_0" */;

    VHI scuba_vhi_inst (.Z(scuba_vhi));

    defparam mem_0_1.initval = "0x0000000000000000" ;
    DPR16X4C mem_0_1 (.DI0(Data[0]), .DI1(Data[1]), .DI2(Data[2]), .DI3(Data[3]), 
        .WCK(WrClock), .WRE(dec0_wre3), .RAD0(RdAddress[0]), .RAD1(RdAddress[1]), 
        .RAD2(scuba_vhi), .RAD3(scuba_vhi), .WAD0(WrAddress[0]), .WAD1(WrAddress[1]), 
        .WAD2(scuba_vhi), .WAD3(scuba_vhi), .DO0(dataout0_ffin), .DO1(dataout1_ffin), 
        .DO2(dataout2_ffin), .DO3(dataout3_ffin))
             /* synthesis MEM_INIT_FILE="(0-3)(4-7)" */
             /* synthesis MEM_LPC_FILE="pmi_distributed_dpramXbnoner7248b8bbf2__PMI__4__7__7B" */
             /* synthesis COMP="mem_0_1" */;



    // exemplar begin
    // exemplar attribute FF_6 GSR ENABLED
    // exemplar attribute FF_5 GSR ENABLED
    // exemplar attribute FF_4 GSR ENABLED
    // exemplar attribute FF_3 GSR ENABLED
    // exemplar attribute FF_2 GSR ENABLED
    // exemplar attribute FF_1 GSR ENABLED
    // exemplar attribute FF_0 GSR ENABLED
    // exemplar attribute mem_0_0 MEM_INIT_FILE (0-3)(0-3)
    // exemplar attribute mem_0_0 MEM_LPC_FILE pmi_distributed_dpramXbnoner7248b8bbf2__PMI__4__7__7B
    // exemplar attribute mem_0_0 COMP mem_0_0
    // exemplar attribute mem_0_1 MEM_INIT_FILE (0-3)(4-7)
    // exemplar attribute mem_0_1 MEM_LPC_FILE pmi_distributed_dpramXbnoner7248b8bbf2__PMI__4__7__7B
    // exemplar attribute mem_0_1 COMP mem_0_1
    // exemplar end

endmodule
/* Verilog netlist generated by SCUBA Diamond (64-bit) 3.12.1.454 */
/* Module Version: 6.5 */
/* D:/Lattice/diamond/3.12/ispfpga/bin/nt64/scuba -w -bus_exp 7 -bb -arch xo2c00 -type bram -wp 10 -rp 0011 -data_width 18 -num_rows 128 -rdata_width 18 -read_reg1 outreg -gsr DISABLED -reset_rel async -memformat bin -cascade -1 -n pmi_ram_dpXbnonesadr18712818712811ac94bd -pmi -lang verilog  */
/* Sat Jan 14 16:28:00 2023 */


`timescale 1 ns / 1 ps
module pmi_ram_dpXbnonesadr18712818712811ac94bd (WrAddress, RdAddress, 
    Data, WE, RdClock, RdClockEn, Reset, WrClock, WrClockEn, Q)/* synthesis NGD_DRC_MASK=1 */;
    input wire [6:0] WrAddress;
    input wire [6:0] RdAddress;
    input wire [17:0] Data;
    input wire WE;
    input wire RdClock;
    input wire RdClockEn;
    input wire Reset;
    input wire WrClock;
    input wire WrClockEn;
    output wire [17:0] Q;

    wire scuba_vhi;
    wire scuba_vlo;

    VHI scuba_vhi_inst (.Z(scuba_vhi));

    VLO scuba_vlo_inst (.Z(scuba_vlo));

    defparam pmi_ram_dpXbnonesadr18712818712811ac94bd_0_0_0.INIT_DATA = "STATIC" ;
    defparam pmi_ram_dpXbnonesadr18712818712811ac94bd_0_0_0.ASYNC_RESET_RELEASE = "ASYNC" ;
    defparam pmi_ram_dpXbnonesadr18712818712811ac94bd_0_0_0.CSDECODE_R = "0b000" ;
    defparam pmi_ram_dpXbnonesadr18712818712811ac94bd_0_0_0.CSDECODE_W = "0b001" ;
    defparam pmi_ram_dpXbnonesadr18712818712811ac94bd_0_0_0.GSR = "ENABLED" ;
    defparam pmi_ram_dpXbnonesadr18712818712811ac94bd_0_0_0.RESETMODE = "ASYNC" ;
    defparam pmi_ram_dpXbnonesadr18712818712811ac94bd_0_0_0.REGMODE = "OUTREG" ;
    defparam pmi_ram_dpXbnonesadr18712818712811ac94bd_0_0_0.DATA_WIDTH_R = 18 ;
    defparam pmi_ram_dpXbnonesadr18712818712811ac94bd_0_0_0.DATA_WIDTH_W = 18 ;
    PDPW8KC pmi_ram_dpXbnonesadr18712818712811ac94bd_0_0_0 (.DI17(Data[17]), 
        .DI16(Data[16]), .DI15(Data[15]), .DI14(Data[14]), .DI13(Data[13]), 
        .DI12(Data[12]), .DI11(Data[11]), .DI10(Data[10]), .DI9(Data[9]), 
        .DI8(Data[8]), .DI7(Data[7]), .DI6(Data[6]), .DI5(Data[5]), .DI4(Data[4]), 
        .DI3(Data[3]), .DI2(Data[2]), .DI1(Data[1]), .DI0(Data[0]), .ADW8(scuba_vlo), 
        .ADW7(scuba_vlo), .ADW6(WrAddress[6]), .ADW5(WrAddress[5]), .ADW4(WrAddress[4]), 
        .ADW3(WrAddress[3]), .ADW2(WrAddress[2]), .ADW1(WrAddress[1]), .ADW0(WrAddress[0]), 
        .BE1(scuba_vhi), .BE0(scuba_vhi), .CEW(WrClockEn), .CLKW(WrClock), 
        .CSW2(scuba_vlo), .CSW1(scuba_vlo), .CSW0(WE), .ADR12(scuba_vlo), 
        .ADR11(scuba_vlo), .ADR10(RdAddress[6]), .ADR9(RdAddress[5]), .ADR8(RdAddress[4]), 
        .ADR7(RdAddress[3]), .ADR6(RdAddress[2]), .ADR5(RdAddress[1]), .ADR4(RdAddress[0]), 
        .ADR3(scuba_vlo), .ADR2(scuba_vlo), .ADR1(scuba_vlo), .ADR0(scuba_vlo), 
        .CER(RdClockEn), .OCER(RdClockEn), .CLKR(RdClock), .CSR2(scuba_vlo), 
        .CSR1(scuba_vlo), .CSR0(scuba_vlo), .RST(Reset), .DO17(Q[8]), .DO16(Q[7]), 
        .DO15(Q[6]), .DO14(Q[5]), .DO13(Q[4]), .DO12(Q[3]), .DO11(Q[2]), 
        .DO10(Q[1]), .DO9(Q[0]), .DO8(Q[17]), .DO7(Q[16]), .DO6(Q[15]), 
        .DO5(Q[14]), .DO4(Q[13]), .DO3(Q[12]), .DO2(Q[11]), .DO1(Q[10]), 
        .DO0(Q[9]))
             /* synthesis MEM_LPC_FILE="pmi_ram_dpXbnonesadr18712818712811ac94bd__PMIP__128__18__18B" */
             /* synthesis MEM_INIT_FILE="" */;



    // exemplar begin
    // exemplar attribute pmi_ram_dpXbnonesadr18712818712811ac94bd_0_0_0 MEM_LPC_FILE pmi_ram_dpXbnonesadr18712818712811ac94bd__PMIP__128__18__18B
    // exemplar attribute pmi_ram_dpXbnonesadr18712818712811ac94bd_0_0_0 MEM_INIT_FILE 
    // exemplar end

endmodule
/* Verilog netlist generated by SCUBA Diamond (64-bit) 3.12.1.454 */
/* Module Version: 6.5 */
/* D:/Lattice/diamond/3.12/ispfpga/bin/nt64/scuba -w -bus_exp 7 -bb -arch xo2c00 -type bram -wp 10 -rp 0011 -data_width 1 -num_rows 4 -rdata_width 1 -read_reg1 outreg -gsr DISABLED -reset_rel async -memformat bin -cascade -1 -n pmi_ram_dpXbnonesadr1241241140333e -pmi -lang verilog  */
/* Sat Jan 14 16:28:22 2023 */


`timescale 1 ns / 1 ps
module pmi_ram_dpXbnonesadr1241241140333e (WrAddress, RdAddress, Data, 
    WE, RdClock, RdClockEn, Reset, WrClock, WrClockEn, Q)/* synthesis NGD_DRC_MASK=1 */;
    input wire [1:0] WrAddress;
    input wire [1:0] RdAddress;
    input wire [0:0] Data;
    input wire WE;
    input wire RdClock;
    input wire RdClockEn;
    input wire Reset;
    input wire WrClock;
    input wire WrClockEn;
    output wire [0:0] Q;

    wire scuba_vhi;
    wire scuba_vlo;

    VHI scuba_vhi_inst (.Z(scuba_vhi));

    VLO scuba_vlo_inst (.Z(scuba_vlo));

    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.INIT_DATA = "STATIC" ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.ASYNC_RESET_RELEASE = "ASYNC" ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.CSDECODE_B = "0b000" ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.CSDECODE_A = "0b000" ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.WRITEMODE_B = "NORMAL" ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.WRITEMODE_A = "NORMAL" ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.GSR = "ENABLED" ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.RESETMODE = "ASYNC" ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.REGMODE_B = "OUTREG" ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.REGMODE_A = "OUTREG" ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.DATA_WIDTH_B = 1 ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.DATA_WIDTH_A = 1 ;
    DP8KC pmi_ram_dpXbnonesadr1241241140333e_0_0_0 (.DIA8(scuba_vlo), .DIA7(scuba_vlo), 
        .DIA6(scuba_vlo), .DIA5(scuba_vlo), .DIA4(scuba_vlo), .DIA3(scuba_vlo), 
        .DIA2(scuba_vlo), .DIA1(Data[0]), .DIA0(scuba_vlo), .ADA12(scuba_vlo), 
        .ADA11(scuba_vlo), .ADA10(scuba_vlo), .ADA9(scuba_vlo), .ADA8(scuba_vlo), 
        .ADA7(scuba_vlo), .ADA6(scuba_vlo), .ADA5(scuba_vlo), .ADA4(scuba_vlo), 
        .ADA3(scuba_vlo), .ADA2(scuba_vlo), .ADA1(WrAddress[1]), .ADA0(WrAddress[0]), 
        .CEA(WrClockEn), .OCEA(WrClockEn), .CLKA(WrClock), .WEA(WE), .CSA2(scuba_vlo), 
        .CSA1(scuba_vlo), .CSA0(scuba_vlo), .RSTA(Reset), .DIB8(scuba_vlo), 
        .DIB7(scuba_vlo), .DIB6(scuba_vlo), .DIB5(scuba_vlo), .DIB4(scuba_vlo), 
        .DIB3(scuba_vlo), .DIB2(scuba_vlo), .DIB1(scuba_vlo), .DIB0(scuba_vlo), 
        .ADB12(scuba_vlo), .ADB11(scuba_vlo), .ADB10(scuba_vlo), .ADB9(scuba_vlo), 
        .ADB8(scuba_vlo), .ADB7(scuba_vlo), .ADB6(scuba_vlo), .ADB5(scuba_vlo), 
        .ADB4(scuba_vlo), .ADB3(scuba_vlo), .ADB2(scuba_vlo), .ADB1(RdAddress[1]), 
        .ADB0(RdAddress[0]), .CEB(RdClockEn), .OCEB(RdClockEn), .CLKB(RdClock), 
        .WEB(scuba_vlo), .CSB2(scuba_vlo), .CSB1(scuba_vlo), .CSB0(scuba_vlo), 
        .RSTB(Reset), .DOA8(), .DOA7(), .DOA6(), .DOA5(), .DOA4(), .DOA3(), 
        .DOA2(), .DOA1(), .DOA0(), .DOB8(), .DOB7(), .DOB6(), .DOB5(), .DOB4(), 
        .DOB3(), .DOB2(), .DOB1(), .DOB0(Q[0]))
             /* synthesis MEM_LPC_FILE="pmi_ram_dpXbnonesadr1241241140333e__PMIP__4__1__1B" */
             /* synthesis MEM_INIT_FILE="" */;



    // exemplar begin
    // exemplar attribute pmi_ram_dpXbnonesadr1241241140333e_0_0_0 MEM_LPC_FILE pmi_ram_dpXbnonesadr1241241140333e__PMIP__4__1__1B
    // exemplar attribute pmi_ram_dpXbnonesadr1241241140333e_0_0_0 MEM_INIT_FILE 
    // exemplar end

endmodule
/* Verilog netlist generated by SCUBA Diamond (64-bit) 3.12.1.454 */
/* Module Version: 3.9 */
/* D:/Lattice/diamond/3.12/ispfpga/bin/nt64/scuba -w -bus_exp 7 -bb -arch xo2c00 -type sdpram -num_rows 4 -data_width 7 -pipe_final_output -memformat bin -n pmi_distributed_dpramXbnoner7248b8bbf2 -pmi -lang verilog  */
/* Sat Jan 14 16:28:22 2023 */


`timescale 1 ns / 1 ps
module pmi_distributed_dpramXbnoner7248b8bbf2 (WrAddress, Data, WrClock, 
    WE, WrClockEn, RdAddress, RdClock, RdClockEn, Reset, Q)/* synthesis NGD_DRC_MASK=1 */;
    input wire [1:0] WrAddress;
    input wire [6:0] Data;
    input wire WrClock;
    input wire WE;
    input wire WrClockEn;
    input wire [1:0] RdAddress;
    input wire RdClock;
    input wire RdClockEn;
    input wire Reset;
    output wire [6:0] Q;

    wire dataout6_ffin;
    wire dataout5_ffin;
    wire dataout4_ffin;
    wire dataout3_ffin;
    wire dataout2_ffin;
    wire dataout1_ffin;
    wire dataout0_ffin;
    wire dec0_wre3;
    wire scuba_vhi;

    defparam LUT4_0.initval =  16'h8000 ;
    ROM16X1A LUT4_0 (.AD3(WE), .AD2(WrClockEn), .AD1(scuba_vhi), .AD0(scuba_vhi), 
        .DO0(dec0_wre3));

    FD1P3DX FF_6 (.D(dataout6_ffin), .SP(RdClockEn), .CK(RdClock), .CD(Reset), 
        .Q(Q[6]))
             /* synthesis GSR="ENABLED" */;

    FD1P3DX FF_5 (.D(dataout5_ffin), .SP(RdClockEn), .CK(RdClock), .CD(Reset), 
        .Q(Q[5]))
             /* synthesis GSR="ENABLED" */;

    FD1P3DX FF_4 (.D(dataout4_ffin), .SP(RdClockEn), .CK(RdClock), .CD(Reset), 
        .Q(Q[4]))
             /* synthesis GSR="ENABLED" */;

    FD1P3DX FF_3 (.D(dataout3_ffin), .SP(RdClockEn), .CK(RdClock), .CD(Reset), 
        .Q(Q[3]))
             /* synthesis GSR="ENABLED" */;

    FD1P3DX FF_2 (.D(dataout2_ffin), .SP(RdClockEn), .CK(RdClock), .CD(Reset), 
        .Q(Q[2]))
             /* synthesis GSR="ENABLED" */;

    FD1P3DX FF_1 (.D(dataout1_ffin), .SP(RdClockEn), .CK(RdClock), .CD(Reset), 
        .Q(Q[1]))
             /* synthesis GSR="ENABLED" */;

    FD1P3DX FF_0 (.D(dataout0_ffin), .SP(RdClockEn), .CK(RdClock), .CD(Reset), 
        .Q(Q[0]))
             /* synthesis GSR="ENABLED" */;

    defparam mem_0_0.initval = "0x0000000000000000" ;
    DPR16X4C mem_0_0 (.DI0(Data[4]), .DI1(Data[5]), .DI2(Data[6]), .DI3(scuba_vhi), 
        .WCK(WrClock), .WRE(dec0_wre3), .RAD0(RdAddress[0]), .RAD1(RdAddress[1]), 
        .RAD2(scuba_vhi), .RAD3(scuba_vhi), .WAD0(WrAddress[0]), .WAD1(WrAddress[1]), 
        .WAD2(scuba_vhi), .WAD3(scuba_vhi), .DO0(dataout4_ffin), .DO1(dataout5_ffin), 
        .DO2(dataout6_ffin), .DO3())
             /* synthesis MEM_INIT_FILE="(0-3)(0-3)" */
             /* synthesis MEM_LPC_FILE="pmi_distributed_dpramXbnoner7248b8bbf2__PMI__4__7__7B" */
             /* synthesis COMP="mem_0_0" */;

    VHI scuba_vhi_inst (.Z(scuba_vhi));

    defparam mem_0_1.initval = "0x0000000000000000" ;
    DPR16X4C mem_0_1 (.DI0(Data[0]), .DI1(Data[1]), .DI2(Data[2]), .DI3(Data[3]), 
        .WCK(WrClock), .WRE(dec0_wre3), .RAD0(RdAddress[0]), .RAD1(RdAddress[1]), 
        .RAD2(scuba_vhi), .RAD3(scuba_vhi), .WAD0(WrAddress[0]), .WAD1(WrAddress[1]), 
        .WAD2(scuba_vhi), .WAD3(scuba_vhi), .DO0(dataout0_ffin), .DO1(dataout1_ffin), 
        .DO2(dataout2_ffin), .DO3(dataout3_ffin))
             /* synthesis MEM_INIT_FILE="(0-3)(4-7)" */
             /* synthesis MEM_LPC_FILE="pmi_distributed_dpramXbnoner7248b8bbf2__PMI__4__7__7B" */
             /* synthesis COMP="mem_0_1" */;



    // exemplar begin
    // exemplar attribute FF_6 GSR ENABLED
    // exemplar attribute FF_5 GSR ENABLED
    // exemplar attribute FF_4 GSR ENABLED
    // exemplar attribute FF_3 GSR ENABLED
    // exemplar attribute FF_2 GSR ENABLED
    // exemplar attribute FF_1 GSR ENABLED
    // exemplar attribute FF_0 GSR ENABLED
    // exemplar attribute mem_0_0 MEM_INIT_FILE (0-3)(0-3)
    // exemplar attribute mem_0_0 MEM_LPC_FILE pmi_distributed_dpramXbnoner7248b8bbf2__PMI__4__7__7B
    // exemplar attribute mem_0_0 COMP mem_0_0
    // exemplar attribute mem_0_1 MEM_INIT_FILE (0-3)(4-7)
    // exemplar attribute mem_0_1 MEM_LPC_FILE pmi_distributed_dpramXbnoner7248b8bbf2__PMI__4__7__7B
    // exemplar attribute mem_0_1 COMP mem_0_1
    // exemplar end

endmodule
/* Verilog netlist generated by SCUBA Diamond (64-bit) 3.12.1.454 */
/* Module Version: 6.5 */
/* D:/Lattice/diamond/3.12/ispfpga/bin/nt64/scuba -w -bus_exp 7 -bb -arch xo2c00 -type bram -wp 10 -rp 0011 -data_width 18 -num_rows 128 -rdata_width 18 -read_reg1 outreg -gsr DISABLED -reset_rel async -memformat bin -cascade -1 -n pmi_ram_dpXbnonesadr18712818712811ac94bd -pmi -lang verilog  */
/* Sat Jan 14 16:28:22 2023 */


`timescale 1 ns / 1 ps
module pmi_ram_dpXbnonesadr18712818712811ac94bd (WrAddress, RdAddress, 
    Data, WE, RdClock, RdClockEn, Reset, WrClock, WrClockEn, Q)/* synthesis NGD_DRC_MASK=1 */;
    input wire [6:0] WrAddress;
    input wire [6:0] RdAddress;
    input wire [17:0] Data;
    input wire WE;
    input wire RdClock;
    input wire RdClockEn;
    input wire Reset;
    input wire WrClock;
    input wire WrClockEn;
    output wire [17:0] Q;

    wire scuba_vhi;
    wire scuba_vlo;

    VHI scuba_vhi_inst (.Z(scuba_vhi));

    VLO scuba_vlo_inst (.Z(scuba_vlo));

    defparam pmi_ram_dpXbnonesadr18712818712811ac94bd_0_0_0.INIT_DATA = "STATIC" ;
    defparam pmi_ram_dpXbnonesadr18712818712811ac94bd_0_0_0.ASYNC_RESET_RELEASE = "ASYNC" ;
    defparam pmi_ram_dpXbnonesadr18712818712811ac94bd_0_0_0.CSDECODE_R = "0b000" ;
    defparam pmi_ram_dpXbnonesadr18712818712811ac94bd_0_0_0.CSDECODE_W = "0b001" ;
    defparam pmi_ram_dpXbnonesadr18712818712811ac94bd_0_0_0.GSR = "ENABLED" ;
    defparam pmi_ram_dpXbnonesadr18712818712811ac94bd_0_0_0.RESETMODE = "ASYNC" ;
    defparam pmi_ram_dpXbnonesadr18712818712811ac94bd_0_0_0.REGMODE = "OUTREG" ;
    defparam pmi_ram_dpXbnonesadr18712818712811ac94bd_0_0_0.DATA_WIDTH_R = 18 ;
    defparam pmi_ram_dpXbnonesadr18712818712811ac94bd_0_0_0.DATA_WIDTH_W = 18 ;
    PDPW8KC pmi_ram_dpXbnonesadr18712818712811ac94bd_0_0_0 (.DI17(Data[17]), 
        .DI16(Data[16]), .DI15(Data[15]), .DI14(Data[14]), .DI13(Data[13]), 
        .DI12(Data[12]), .DI11(Data[11]), .DI10(Data[10]), .DI9(Data[9]), 
        .DI8(Data[8]), .DI7(Data[7]), .DI6(Data[6]), .DI5(Data[5]), .DI4(Data[4]), 
        .DI3(Data[3]), .DI2(Data[2]), .DI1(Data[1]), .DI0(Data[0]), .ADW8(scuba_vlo), 
        .ADW7(scuba_vlo), .ADW6(WrAddress[6]), .ADW5(WrAddress[5]), .ADW4(WrAddress[4]), 
        .ADW3(WrAddress[3]), .ADW2(WrAddress[2]), .ADW1(WrAddress[1]), .ADW0(WrAddress[0]), 
        .BE1(scuba_vhi), .BE0(scuba_vhi), .CEW(WrClockEn), .CLKW(WrClock), 
        .CSW2(scuba_vlo), .CSW1(scuba_vlo), .CSW0(WE), .ADR12(scuba_vlo), 
        .ADR11(scuba_vlo), .ADR10(RdAddress[6]), .ADR9(RdAddress[5]), .ADR8(RdAddress[4]), 
        .ADR7(RdAddress[3]), .ADR6(RdAddress[2]), .ADR5(RdAddress[1]), .ADR4(RdAddress[0]), 
        .ADR3(scuba_vlo), .ADR2(scuba_vlo), .ADR1(scuba_vlo), .ADR0(scuba_vlo), 
        .CER(RdClockEn), .OCER(RdClockEn), .CLKR(RdClock), .CSR2(scuba_vlo), 
        .CSR1(scuba_vlo), .CSR0(scuba_vlo), .RST(Reset), .DO17(Q[8]), .DO16(Q[7]), 
        .DO15(Q[6]), .DO14(Q[5]), .DO13(Q[4]), .DO12(Q[3]), .DO11(Q[2]), 
        .DO10(Q[1]), .DO9(Q[0]), .DO8(Q[17]), .DO7(Q[16]), .DO6(Q[15]), 
        .DO5(Q[14]), .DO4(Q[13]), .DO3(Q[12]), .DO2(Q[11]), .DO1(Q[10]), 
        .DO0(Q[9]))
             /* synthesis MEM_LPC_FILE="pmi_ram_dpXbnonesadr18712818712811ac94bd__PMIP__128__18__18B" */
             /* synthesis MEM_INIT_FILE="" */;



    // exemplar begin
    // exemplar attribute pmi_ram_dpXbnonesadr18712818712811ac94bd_0_0_0 MEM_LPC_FILE pmi_ram_dpXbnonesadr18712818712811ac94bd__PMIP__128__18__18B
    // exemplar attribute pmi_ram_dpXbnonesadr18712818712811ac94bd_0_0_0 MEM_INIT_FILE 
    // exemplar end

endmodule
/* Verilog netlist generated by SCUBA Diamond (64-bit) 3.12.1.454 */
/* Module Version: 6.5 */
/* D:/Lattice/diamond/3.12/ispfpga/bin/nt64/scuba -w -bus_exp 7 -bb -arch xo2c00 -type bram -wp 10 -rp 0011 -data_width 1 -num_rows 4 -rdata_width 1 -read_reg1 outreg -gsr DISABLED -reset_rel async -memformat bin -cascade -1 -n pmi_ram_dpXbnonesadr1241241140333e -pmi -lang verilog  */
/* Sat Jan 14 16:31:17 2023 */


`timescale 1 ns / 1 ps
module pmi_ram_dpXbnonesadr1241241140333e (WrAddress, RdAddress, Data, 
    WE, RdClock, RdClockEn, Reset, WrClock, WrClockEn, Q)/* synthesis NGD_DRC_MASK=1 */;
    input wire [1:0] WrAddress;
    input wire [1:0] RdAddress;
    input wire [0:0] Data;
    input wire WE;
    input wire RdClock;
    input wire RdClockEn;
    input wire Reset;
    input wire WrClock;
    input wire WrClockEn;
    output wire [0:0] Q;

    wire scuba_vhi;
    wire scuba_vlo;

    VHI scuba_vhi_inst (.Z(scuba_vhi));

    VLO scuba_vlo_inst (.Z(scuba_vlo));

    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.INIT_DATA = "STATIC" ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.ASYNC_RESET_RELEASE = "ASYNC" ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.CSDECODE_B = "0b000" ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.CSDECODE_A = "0b000" ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.WRITEMODE_B = "NORMAL" ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.WRITEMODE_A = "NORMAL" ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.GSR = "ENABLED" ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.RESETMODE = "ASYNC" ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.REGMODE_B = "OUTREG" ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.REGMODE_A = "OUTREG" ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.DATA_WIDTH_B = 1 ;
    defparam pmi_ram_dpXbnonesadr1241241140333e_0_0_0.DATA_WIDTH_A = 1 ;
    DP8KC pmi_ram_dpXbnonesadr1241241140333e_0_0_0 (.DIA8(scuba_vlo), .DIA7(scuba_vlo), 
        .DIA6(scuba_vlo), .DIA5(scuba_vlo), .DIA4(scuba_vlo), .DIA3(scuba_vlo), 
        .DIA2(scuba_vlo), .DIA1(Data[0]), .DIA0(scuba_vlo), .ADA12(scuba_vlo), 
        .ADA11(scuba_vlo), .ADA10(scuba_vlo), .ADA9(scuba_vlo), .ADA8(scuba_vlo), 
        .ADA7(scuba_vlo), .ADA6(scuba_vlo), .ADA5(scuba_vlo), .ADA4(scuba_vlo), 
        .ADA3(scuba_vlo), .ADA2(scuba_vlo), .ADA1(WrAddress[1]), .ADA0(WrAddress[0]), 
        .CEA(WrClockEn), .OCEA(WrClockEn), .CLKA(WrClock), .WEA(WE), .CSA2(scuba_vlo), 
        .CSA1(scuba_vlo), .CSA0(scuba_vlo), .RSTA(Reset), .DIB8(scuba_vlo), 
        .DIB7(scuba_vlo), .DIB6(scuba_vlo), .DIB5(scuba_vlo), .DIB4(scuba_vlo), 
        .DIB3(scuba_vlo), .DIB2(scuba_vlo), .DIB1(scuba_vlo), .DIB0(scuba_vlo), 
        .ADB12(scuba_vlo), .ADB11(scuba_vlo), .ADB10(scuba_vlo), .ADB9(scuba_vlo), 
        .ADB8(scuba_vlo), .ADB7(scuba_vlo), .ADB6(scuba_vlo), .ADB5(scuba_vlo), 
        .ADB4(scuba_vlo), .ADB3(scuba_vlo), .ADB2(scuba_vlo), .ADB1(RdAddress[1]), 
        .ADB0(RdAddress[0]), .CEB(RdClockEn), .OCEB(RdClockEn), .CLKB(RdClock), 
        .WEB(scuba_vlo), .CSB2(scuba_vlo), .CSB1(scuba_vlo), .CSB0(scuba_vlo), 
        .RSTB(Reset), .DOA8(), .DOA7(), .DOA6(), .DOA5(), .DOA4(), .DOA3(), 
        .DOA2(), .DOA1(), .DOA0(), .DOB8(), .DOB7(), .DOB6(), .DOB5(), .DOB4(), 
        .DOB3(), .DOB2(), .DOB1(), .DOB0(Q[0]))
             /* synthesis MEM_LPC_FILE="pmi_ram_dpXbnonesadr1241241140333e__PMIP__4__1__1B" */
             /* synthesis MEM_INIT_FILE="" */;



    // exemplar begin
    // exemplar attribute pmi_ram_dpXbnonesadr1241241140333e_0_0_0 MEM_LPC_FILE pmi_ram_dpXbnonesadr1241241140333e__PMIP__4__1__1B
    // exemplar attribute pmi_ram_dpXbnonesadr1241241140333e_0_0_0 MEM_INIT_FILE 
    // exemplar end

endmodule
/* Verilog netlist generated by SCUBA Diamond (64-bit) 3.12.1.454 */
/* Module Version: 3.9 */
/* D:/Lattice/diamond/3.12/ispfpga/bin/nt64/scuba -w -bus_exp 7 -bb -arch xo2c00 -type sdpram -num_rows 4 -data_width 7 -pipe_final_output -memformat bin -n pmi_distributed_dpramXbnoner7248b8bbf2 -pmi -lang verilog  */
/* Sat Jan 14 16:31:17 2023 */


`timescale 1 ns / 1 ps
module pmi_distributed_dpramXbnoner7248b8bbf2 (WrAddress, Data, WrClock, 
    WE, WrClockEn, RdAddress, RdClock, RdClockEn, Reset, Q)/* synthesis NGD_DRC_MASK=1 */;
    input wire [1:0] WrAddress;
    input wire [6:0] Data;
    input wire WrClock;
    input wire WE;
    input wire WrClockEn;
    input wire [1:0] RdAddress;
    input wire RdClock;
    input wire RdClockEn;
    input wire Reset;
    output wire [6:0] Q;

    wire dataout6_ffin;
    wire dataout5_ffin;
    wire dataout4_ffin;
    wire dataout3_ffin;
    wire dataout2_ffin;
    wire dataout1_ffin;
    wire dataout0_ffin;
    wire dec0_wre3;
    wire scuba_vhi;

    defparam LUT4_0.initval =  16'h8000 ;
    ROM16X1A LUT4_0 (.AD3(WE), .AD2(WrClockEn), .AD1(scuba_vhi), .AD0(scuba_vhi), 
        .DO0(dec0_wre3));

    FD1P3DX FF_6 (.D(dataout6_ffin), .SP(RdClockEn), .CK(RdClock), .CD(Reset), 
        .Q(Q[6]))
             /* synthesis GSR="ENABLED" */;

    FD1P3DX FF_5 (.D(dataout5_ffin), .SP(RdClockEn), .CK(RdClock), .CD(Reset), 
        .Q(Q[5]))
             /* synthesis GSR="ENABLED" */;

    FD1P3DX FF_4 (.D(dataout4_ffin), .SP(RdClockEn), .CK(RdClock), .CD(Reset), 
        .Q(Q[4]))
             /* synthesis GSR="ENABLED" */;

    FD1P3DX FF_3 (.D(dataout3_ffin), .SP(RdClockEn), .CK(RdClock), .CD(Reset), 
        .Q(Q[3]))
             /* synthesis GSR="ENABLED" */;

    FD1P3DX FF_2 (.D(dataout2_ffin), .SP(RdClockEn), .CK(RdClock), .CD(Reset), 
        .Q(Q[2]))
             /* synthesis GSR="ENABLED" */;

    FD1P3DX FF_1 (.D(dataout1_ffin), .SP(RdClockEn), .CK(RdClock), .CD(Reset), 
        .Q(Q[1]))
             /* synthesis GSR="ENABLED" */;

    FD1P3DX FF_0 (.D(dataout0_ffin), .SP(RdClockEn), .CK(RdClock), .CD(Reset), 
        .Q(Q[0]))
             /* synthesis GSR="ENABLED" */;

    defparam mem_0_0.initval = "0x0000000000000000" ;
    DPR16X4C mem_0_0 (.DI0(Data[4]), .DI1(Data[5]), .DI2(Data[6]), .DI3(scuba_vhi), 
        .WCK(WrClock), .WRE(dec0_wre3), .RAD0(RdAddress[0]), .RAD1(RdAddress[1]), 
        .RAD2(scuba_vhi), .RAD3(scuba_vhi), .WAD0(WrAddress[0]), .WAD1(WrAddress[1]), 
        .WAD2(scuba_vhi), .WAD3(scuba_vhi), .DO0(dataout4_ffin), .DO1(dataout5_ffin), 
        .DO2(dataout6_ffin), .DO3())
             /* synthesis MEM_INIT_FILE="(0-3)(0-3)" */
             /* synthesis MEM_LPC_FILE="pmi_distributed_dpramXbnoner7248b8bbf2__PMI__4__7__7B" */
             /* synthesis COMP="mem_0_0" */;

    VHI scuba_vhi_inst (.Z(scuba_vhi));

    defparam mem_0_1.initval = "0x0000000000000000" ;
    DPR16X4C mem_0_1 (.DI0(Data[0]), .DI1(Data[1]), .DI2(Data[2]), .DI3(Data[3]), 
        .WCK(WrClock), .WRE(dec0_wre3), .RAD0(RdAddress[0]), .RAD1(RdAddress[1]), 
        .RAD2(scuba_vhi), .RAD3(scuba_vhi), .WAD0(WrAddress[0]), .WAD1(WrAddress[1]), 
        .WAD2(scuba_vhi), .WAD3(scuba_vhi), .DO0(dataout0_ffin), .DO1(dataout1_ffin), 
        .DO2(dataout2_ffin), .DO3(dataout3_ffin))
             /* synthesis MEM_INIT_FILE="(0-3)(4-7)" */
             /* synthesis MEM_LPC_FILE="pmi_distributed_dpramXbnoner7248b8bbf2__PMI__4__7__7B" */
             /* synthesis COMP="mem_0_1" */;



    // exemplar begin
    // exemplar attribute FF_6 GSR ENABLED
    // exemplar attribute FF_5 GSR ENABLED
    // exemplar attribute FF_4 GSR ENABLED
    // exemplar attribute FF_3 GSR ENABLED
    // exemplar attribute FF_2 GSR ENABLED
    // exemplar attribute FF_1 GSR ENABLED
    // exemplar attribute FF_0 GSR ENABLED
    // exemplar attribute mem_0_0 MEM_INIT_FILE (0-3)(0-3)
    // exemplar attribute mem_0_0 MEM_LPC_FILE pmi_distributed_dpramXbnoner7248b8bbf2__PMI__4__7__7B
    // exemplar attribute mem_0_0 COMP mem_0_0
    // exemplar attribute mem_0_1 MEM_INIT_FILE (0-3)(4-7)
    // exemplar attribute mem_0_1 MEM_LPC_FILE pmi_distributed_dpramXbnoner7248b8bbf2__PMI__4__7__7B
    // exemplar attribute mem_0_1 COMP mem_0_1
    // exemplar end

endmodule
/* Verilog netlist generated by SCUBA Diamond (64-bit) 3.12.1.454 */
/* Module Version: 6.5 */
/* D:/Lattice/diamond/3.12/ispfpga/bin/nt64/scuba -w -bus_exp 7 -bb -arch xo2c00 -type bram -wp 10 -rp 0011 -data_width 18 -num_rows 128 -rdata_width 18 -read_reg1 outreg -gsr DISABLED -reset_rel async -memformat bin -cascade -1 -n pmi_ram_dpXbnonesadr18712818712811ac94bd -pmi -lang verilog  */
/* Sat Jan 14 16:31:17 2023 */


`timescale 1 ns / 1 ps
module pmi_ram_dpXbnonesadr18712818712811ac94bd (WrAddress, RdAddress, 
    Data, WE, RdClock, RdClockEn, Reset, WrClock, WrClockEn, Q)/* synthesis NGD_DRC_MASK=1 */;
    input wire [6:0] WrAddress;
    input wire [6:0] RdAddress;
    input wire [17:0] Data;
    input wire WE;
    input wire RdClock;
    input wire RdClockEn;
    input wire Reset;
    input wire WrClock;
    input wire WrClockEn;
    output wire [17:0] Q;

    wire scuba_vhi;
    wire scuba_vlo;

    VHI scuba_vhi_inst (.Z(scuba_vhi));

    VLO scuba_vlo_inst (.Z(scuba_vlo));

    defparam pmi_ram_dpXbnonesadr18712818712811ac94bd_0_0_0.INIT_DATA = "STATIC" ;
    defparam pmi_ram_dpXbnonesadr18712818712811ac94bd_0_0_0.ASYNC_RESET_RELEASE = "ASYNC" ;
    defparam pmi_ram_dpXbnonesadr18712818712811ac94bd_0_0_0.CSDECODE_R = "0b000" ;
    defparam pmi_ram_dpXbnonesadr18712818712811ac94bd_0_0_0.CSDECODE_W = "0b001" ;
    defparam pmi_ram_dpXbnonesadr18712818712811ac94bd_0_0_0.GSR = "ENABLED" ;
    defparam pmi_ram_dpXbnonesadr18712818712811ac94bd_0_0_0.RESETMODE = "ASYNC" ;
    defparam pmi_ram_dpXbnonesadr18712818712811ac94bd_0_0_0.REGMODE = "OUTREG" ;
    defparam pmi_ram_dpXbnonesadr18712818712811ac94bd_0_0_0.DATA_WIDTH_R = 18 ;
    defparam pmi_ram_dpXbnonesadr18712818712811ac94bd_0_0_0.DATA_WIDTH_W = 18 ;
    PDPW8KC pmi_ram_dpXbnonesadr18712818712811ac94bd_0_0_0 (.DI17(Data[17]), 
        .DI16(Data[16]), .DI15(Data[15]), .DI14(Data[14]), .DI13(Data[13]), 
        .DI12(Data[12]), .DI11(Data[11]), .DI10(Data[10]), .DI9(Data[9]), 
        .DI8(Data[8]), .DI7(Data[7]), .DI6(Data[6]), .DI5(Data[5]), .DI4(Data[4]), 
        .DI3(Data[3]), .DI2(Data[2]), .DI1(Data[1]), .DI0(Data[0]), .ADW8(scuba_vlo), 
        .ADW7(scuba_vlo), .ADW6(WrAddress[6]), .ADW5(WrAddress[5]), .ADW4(WrAddress[4]), 
        .ADW3(WrAddress[3]), .ADW2(WrAddress[2]), .ADW1(WrAddress[1]), .ADW0(WrAddress[0]), 
        .BE1(scuba_vhi), .BE0(scuba_vhi), .CEW(WrClockEn), .CLKW(WrClock), 
        .CSW2(scuba_vlo), .CSW1(scuba_vlo), .CSW0(WE), .ADR12(scuba_vlo), 
        .ADR11(scuba_vlo), .ADR10(RdAddress[6]), .ADR9(RdAddress[5]), .ADR8(RdAddress[4]), 
        .ADR7(RdAddress[3]), .ADR6(RdAddress[2]), .ADR5(RdAddress[1]), .ADR4(RdAddress[0]), 
        .ADR3(scuba_vlo), .ADR2(scuba_vlo), .ADR1(scuba_vlo), .ADR0(scuba_vlo), 
        .CER(RdClockEn), .OCER(RdClockEn), .CLKR(RdClock), .CSR2(scuba_vlo), 
        .CSR1(scuba_vlo), .CSR0(scuba_vlo), .RST(Reset), .DO17(Q[8]), .DO16(Q[7]), 
        .DO15(Q[6]), .DO14(Q[5]), .DO13(Q[4]), .DO12(Q[3]), .DO11(Q[2]), 
        .DO10(Q[1]), .DO9(Q[0]), .DO8(Q[17]), .DO7(Q[16]), .DO6(Q[15]), 
        .DO5(Q[14]), .DO4(Q[13]), .DO3(Q[12]), .DO2(Q[11]), .DO1(Q[10]), 
        .DO0(Q[9]))
             /* synthesis MEM_LPC_FILE="pmi_ram_dpXbnonesadr18712818712811ac94bd__PMIP__128__18__18B" */
             /* synthesis MEM_INIT_FILE="" */;



    // exemplar begin
    // exemplar attribute pmi_ram_dpXbnonesadr18712818712811ac94bd_0_0_0 MEM_LPC_FILE pmi_ram_dpXbnonesadr18712818712811ac94bd__PMIP__128__18__18B
    // exemplar attribute pmi_ram_dpXbnonesadr18712818712811ac94bd_0_0_0 MEM_INIT_FILE 
    // exemplar end

endmodule
