// Verilog netlist produced by program LSE :  version Diamond (64-bit) 3.12.1.454
// Netlist written on Sat Dec 31 10:22:26 2022
//
// Verilog Description of module top
//

module top (Reset, ButtonUp, ButtonDown, Segments) /* synthesis syn_module_defined=1 */ ;   // d:/lattice/kurs06/impl1/source/top.v(1[8:11])
    input Reset;   // d:/lattice/kurs06/impl1/source/top.v(2[16:21])
    input ButtonUp;   // d:/lattice/kurs06/impl1/source/top.v(3[16:24])
    input ButtonDown;   // d:/lattice/kurs06/impl1/source/top.v(4[16:26])
    output [6:0]Segments;   // d:/lattice/kurs06/impl1/source/top.v(5[15:23])
    
    wire Clock14MHz /* synthesis SET_AS_NETWORK=Clock14MHz, is_clock=1 */ ;   // d:/lattice/kurs06/impl1/source/top.v(13[8:18])
    
    wire GND_net, Reset_c, ButtonUp_c, ButtonDown_c, Segments_c_6, 
        Segments_c_5, Segments_c_4, Segments_c_3, Segments_c_2, Segments_c_1, 
        Segments_c_0, ButtonUpFiltered, ButtonDownFiltered;
    wire [3:0]CountValue;   // d:/lattice/kurs06/impl1/source/top.v(62[13:23])
    
    wire VCC_net;
    wire [3:0]Value_3__N_23;
    
    wire n4, n402, n401;
    
    VHI i361 (.Z(VCC_net));
    OB Segments_pad_3 (.I(Segments_c_3), .O(Segments[3]));   // d:/lattice/kurs06/impl1/source/top.v(5[15:23])
    OSCH OSCH_inst (.STDBY(GND_net), .OSC(Clock14MHz)) /* synthesis syn_instantiated=1 */ ;
    defparam OSCH_inst.NOM_FREQ = "14.00";
    EdgeDetector_U0 DownDetector (.Clock14MHz(Clock14MHz), .ButtonDownFiltered(ButtonDownFiltered), 
            .\CountValue[0] (CountValue[0]), .n402(n402), .\Value_3__N_23[0] (Value_3__N_23[0]), 
            .n401(n401)) /* synthesis syn_module_defined=1 */ ;   // d:/lattice/kurs06/impl1/source/top.v(53[15] 59[3])
    OB Segments_pad_0 (.I(Segments_c_0), .O(Segments[0]));   // d:/lattice/kurs06/impl1/source/top.v(5[15:23])
    OB Segments_pad_1 (.I(Segments_c_1), .O(Segments[1]));   // d:/lattice/kurs06/impl1/source/top.v(5[15:23])
    OB Segments_pad_4 (.I(Segments_c_4), .O(Segments[4]));   // d:/lattice/kurs06/impl1/source/top.v(5[15:23])
    OB Segments_pad_5 (.I(Segments_c_5), .O(Segments[5]));   // d:/lattice/kurs06/impl1/source/top.v(5[15:23])
    OB Segments_pad_6 (.I(Segments_c_6), .O(Segments[6]));   // d:/lattice/kurs06/impl1/source/top.v(5[15:23])
    OB Segments_pad_2 (.I(Segments_c_2), .O(Segments[2]));   // d:/lattice/kurs06/impl1/source/top.v(5[15:23])
    IB Reset_pad (.I(Reset), .O(Reset_c));   // d:/lattice/kurs06/impl1/source/top.v(2[16:21])
    IB ButtonUp_pad (.I(ButtonUp), .O(ButtonUp_c));   // d:/lattice/kurs06/impl1/source/top.v(3[16:24])
    IB ButtonDown_pad (.I(ButtonDown), .O(ButtonDown_c));   // d:/lattice/kurs06/impl1/source/top.v(4[16:26])
    GSR GSR_INST (.GSR(Reset_c));
    Decoder7seg Dekoder0 (.CountValue({CountValue}), .Segments_c_5(Segments_c_5), 
            .Segments_c_3(Segments_c_3), .Segments_c_1(Segments_c_1), .Segments_c_0(Segments_c_0), 
            .Segments_c_4(Segments_c_4), .Segments_c_6(Segments_c_6), .Segments_c_2(Segments_c_2)) /* synthesis syn_module_defined=1 */ ;   // d:/lattice/kurs06/impl1/source/top.v(74[14] 77[3])
    Counter Counter0 (.CountValue({CountValue}), .Clock14MHz(Clock14MHz), 
            .Value_3__N_23({Open_0, Open_1, Open_2, Value_3__N_23[0]}), 
            .\Value_3__N_23[2] (Value_3__N_23[2]), .n402(n402), .n4(n4), 
            .n401(n401)) /* synthesis syn_module_defined=1 */ ;   // d:/lattice/kurs06/impl1/source/top.v(65[4] 71[3])
    \Debouncer(FREQUENCY_MHZ=14,PERIOD_US=1)_U1  DebounceDown (.ButtonDownFiltered(ButtonDownFiltered), 
            .Clock14MHz(Clock14MHz), .ButtonDown_c(ButtonDown_c)) /* synthesis syn_module_defined=1 */ ;   // d:/lattice/kurs06/impl1/source/top.v(34[4] 39[3])
    \Debouncer(FREQUENCY_MHZ=14,PERIOD_US=1)  DebounceUp (.ButtonUp_c(ButtonUp_c), 
            .ButtonUpFiltered(ButtonUpFiltered), .Clock14MHz(Clock14MHz)) /* synthesis syn_module_defined=1 */ ;   // d:/lattice/kurs06/impl1/source/top.v(22[4] 27[3])
    VLO i1 (.Z(GND_net));
    TSALL TSALL_INST (.TSALL(GND_net));
    EdgeDetector UpDetector (.ButtonUpFiltered(ButtonUpFiltered), .n402(n402), 
            .\CountValue[2] (CountValue[2]), .n4(n4), .\Value_3__N_23[2] (Value_3__N_23[2]), 
            .Clock14MHz(Clock14MHz)) /* synthesis syn_module_defined=1 */ ;   // d:/lattice/kurs06/impl1/source/top.v(43[15] 49[3])
    PUR PUR_INST (.PUR(VCC_net));
    defparam PUR_INST.RST_PULSE = 1;
    
endmodule
//
// Verilog Description of module EdgeDetector_U0
//

module EdgeDetector_U0 (Clock14MHz, ButtonDownFiltered, \CountValue[0] , 
            n402, \Value_3__N_23[0] , n401) /* synthesis syn_module_defined=1 */ ;
    input Clock14MHz;
    input ButtonDownFiltered;
    input \CountValue[0] ;
    input n402;
    output \Value_3__N_23[0] ;
    output n401;
    
    wire Clock14MHz /* synthesis SET_AS_NETWORK=Clock14MHz, is_clock=1 */ ;   // d:/lattice/kurs06/impl1/source/top.v(13[8:18])
    
    wire Previous;
    
    FD1S3AX Previous_13 (.D(ButtonDownFiltered), .CK(Clock14MHz), .Q(Previous)) /* synthesis lse_init_val=0, LSE_LINE_FILE_ID=3, LSE_LCOL=15, LSE_RCOL=3, LSE_LLINE=53, LSE_RLINE=59 */ ;   // d:/lattice/kurs06/impl1/source/edge_detector.v(15[7:26])
    defparam Previous_13.GSR = "ENABLED";
    LUT4 i2_3_lut_4_lut (.A(Previous), .B(ButtonDownFiltered), .C(\CountValue[0] ), 
         .D(n402), .Z(\Value_3__N_23[0] )) /* synthesis lut_function=(!(A (C (D)+!C !(D))+!A (B (C)+!B (C (D)+!C !(D))))) */ ;   // d:/lattice/kurs06/impl1/source/edge_detector.v(17[24:62])
    defparam i2_3_lut_4_lut.init = 16'h0fb4;
    LUT4 RisingEdge_I_0_2_lut_rep_13 (.A(Previous), .B(ButtonDownFiltered), 
         .Z(n401)) /* synthesis lut_function=(!(A+!(B))) */ ;   // d:/lattice/kurs06/impl1/source/edge_detector.v(17[24:62])
    defparam RisingEdge_I_0_2_lut_rep_13.init = 16'h4444;
    
endmodule
//
// Verilog Description of module Decoder7seg
//

module Decoder7seg (CountValue, Segments_c_5, Segments_c_3, Segments_c_1, 
            Segments_c_0, Segments_c_4, Segments_c_6, Segments_c_2) /* synthesis syn_module_defined=1 */ ;
    input [3:0]CountValue;
    output Segments_c_5;
    output Segments_c_3;
    output Segments_c_1;
    output Segments_c_0;
    output Segments_c_4;
    output Segments_c_6;
    output Segments_c_2;
    
    
    LUT4 CountValue_1__bdd_4_lut (.A(CountValue[1]), .B(CountValue[0]), 
         .C(CountValue[3]), .D(CountValue[2]), .Z(Segments_c_5)) /* synthesis lut_function=(A (B (C)+!B (C+(D)))+!A !(B (C (D)+!C !(D)))) */ ;
    defparam CountValue_1__bdd_4_lut.init = 16'hb7f1;
    LUT4 i33_4_lut (.A(CountValue[3]), .B(CountValue[1]), .C(CountValue[0]), 
         .D(CountValue[2]), .Z(Segments_c_3)) /* synthesis lut_function=(!(A (B (C (D)+!C !(D)))+!A (B (C (D))+!B !(C (D)+!C !(D))))) */ ;   // d:/lattice/kurs06/impl1/source/decoder7seg.v(7[3] 26[10])
    defparam i33_4_lut.init = 16'h3ee7;
    LUT4 CountValue_1__bdd_4_lut_360 (.A(CountValue[1]), .B(CountValue[3]), 
         .C(CountValue[2]), .D(CountValue[0]), .Z(Segments_c_1)) /* synthesis lut_function=(!(A (B (C+(D))+!B !((D)+!C))+!A !(B ((D)+!C)+!B !(C (D))))) */ ;
    defparam CountValue_1__bdd_4_lut_360.init = 16'h671f;
    LUT4 CountValue_0__bdd_4_lut_359 (.A(CountValue[0]), .B(CountValue[3]), 
         .C(CountValue[1]), .D(CountValue[2]), .Z(Segments_c_0)) /* synthesis lut_function=(A (B (C (D)+!C !(D))+!B (C+(D)))+!A (B+(C+!(D)))) */ ;
    defparam CountValue_0__bdd_4_lut_359.init = 16'hf67d;
    LUT4 CountValue_0__bdd_4_lut (.A(CountValue[0]), .B(CountValue[3]), 
         .C(CountValue[2]), .D(CountValue[1]), .Z(Segments_c_4)) /* synthesis lut_function=(A (B (C+(D)))+!A (B+((D)+!C))) */ ;
    defparam CountValue_0__bdd_4_lut.init = 16'hddc5;
    LUT4 CountValue_3__bdd_4_lut (.A(CountValue[3]), .B(CountValue[1]), 
         .C(CountValue[0]), .D(CountValue[2]), .Z(Segments_c_6)) /* synthesis lut_function=(A (B+(C+!(D)))+!A !(B (C (D))+!B !(D))) */ ;
    defparam CountValue_3__bdd_4_lut.init = 16'hbdee;
    LUT4 Data_3__I_0_Mux_2_i15_4_lut (.A(CountValue[2]), .B(CountValue[0]), 
         .C(CountValue[3]), .D(CountValue[1]), .Z(Segments_c_2)) /* synthesis lut_function=(!(A (B (C (D))+!B (C))+!A !(B+(C+!(D))))) */ ;   // d:/lattice/kurs06/impl1/source/decoder7seg.v(7[3] 26[10])
    defparam Data_3__I_0_Mux_2_i15_4_lut.init = 16'h5edf;
    
endmodule
//
// Verilog Description of module Counter
//

module Counter (CountValue, Clock14MHz, Value_3__N_23, \Value_3__N_23[2] , 
            n402, n4, n401) /* synthesis syn_module_defined=1 */ ;
    output [3:0]CountValue;
    input Clock14MHz;
    input [3:0]Value_3__N_23;
    input \Value_3__N_23[2] ;
    input n402;
    output n4;
    input n401;
    
    wire Clock14MHz /* synthesis SET_AS_NETWORK=Clock14MHz, is_clock=1 */ ;   // d:/lattice/kurs06/impl1/source/top.v(13[8:18])
    wire [3:0]Value_3__N_23_c;
    
    FD1S3AX Value_i0 (.D(Value_3__N_23[0]), .CK(Clock14MHz), .Q(CountValue[0])) /* synthesis LSE_LINE_FILE_ID=3, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=65, LSE_RLINE=71 */ ;   // d:/lattice/kurs06/impl1/source/counter.v(14[8] 17[26])
    defparam Value_i0.GSR = "ENABLED";
    FD1S3AX Value_i3 (.D(Value_3__N_23_c[3]), .CK(Clock14MHz), .Q(CountValue[3])) /* synthesis LSE_LINE_FILE_ID=3, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=65, LSE_RLINE=71 */ ;   // d:/lattice/kurs06/impl1/source/counter.v(14[8] 17[26])
    defparam Value_i3.GSR = "ENABLED";
    FD1S3AX Value_i2 (.D(\Value_3__N_23[2] ), .CK(Clock14MHz), .Q(CountValue[2])) /* synthesis LSE_LINE_FILE_ID=3, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=65, LSE_RLINE=71 */ ;   // d:/lattice/kurs06/impl1/source/counter.v(14[8] 17[26])
    defparam Value_i2.GSR = "ENABLED";
    FD1S3AX Value_i1 (.D(Value_3__N_23_c[1]), .CK(Clock14MHz), .Q(CountValue[1])) /* synthesis LSE_LINE_FILE_ID=3, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=65, LSE_RLINE=71 */ ;   // d:/lattice/kurs06/impl1/source/counter.v(14[8] 17[26])
    defparam Value_i1.GSR = "ENABLED";
    LUT4 i2_4_lut (.A(CountValue[2]), .B(n402), .C(CountValue[3]), .D(n4), 
         .Z(Value_3__N_23_c[3])) /* synthesis lut_function=(!(A (B (C (D)+!C !(D))+!B !(C))+!A !(B (C)+!B (C (D)+!C !(D))))) */ ;
    defparam i2_4_lut.init = 16'h78e1;
    LUT4 i70_4_lut (.A(CountValue[1]), .B(n402), .C(n401), .D(CountValue[0]), 
         .Z(n4)) /* synthesis lut_function=(A ((D)+!B)+!A !(B+!((D)+!C))) */ ;   // d:/lattice/kurs06/impl1/source/counter.v(16[8] 17[26])
    defparam i70_4_lut.init = 16'hbb23;
    LUT4 i2_4_lut_adj_2 (.A(CountValue[0]), .B(n402), .C(n401), .D(CountValue[1]), 
         .Z(Value_3__N_23_c[1])) /* synthesis lut_function=(!(A (B (D)+!B !(D))+!A !(B (D)+!B !(C (D)+!C !(D))))) */ ;
    defparam i2_4_lut_adj_2.init = 16'h6798;
    
endmodule
//
// Verilog Description of module \Debouncer(FREQUENCY_MHZ=14,PERIOD_US=1)_U1 
//

module \Debouncer(FREQUENCY_MHZ=14,PERIOD_US=1)_U1  (ButtonDownFiltered, Clock14MHz, 
            ButtonDown_c) /* synthesis syn_module_defined=1 */ ;
    output ButtonDownFiltered;
    input Clock14MHz;
    input ButtonDown_c;
    
    wire Clock14MHz /* synthesis SET_AS_NETWORK=Clock14MHz, is_clock=1 */ ;   // d:/lattice/kurs06/impl1/source/top.v(13[8:18])
    wire [3:0]Counter;   // d:/lattice/kurs06/impl1/source/debouncer.v(13[19:26])
    
    wire Clock14MHz_enable_1, n189;
    wire [3:0]n21;
    
    wire n201, n400;
    
    LUT4 i1_2_lut_4_lut (.A(Counter[3]), .B(Counter[1]), .C(Counter[2]), 
         .D(Counter[0]), .Z(Clock14MHz_enable_1)) /* synthesis lut_function=(!((((D)+!C)+!B)+!A)) */ ;   // d:/lattice/kurs06/impl1/source/debouncer.v(20[18:32])
    defparam i1_2_lut_4_lut.init = 16'h0080;
    FD1P3AX FilteredSignal_17 (.D(ButtonDown_c), .SP(Clock14MHz_enable_1), 
            .CK(Clock14MHz), .Q(ButtonDownFiltered)) /* synthesis LSE_LINE_FILE_ID=3, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=34, LSE_RLINE=39 */ ;   // d:/lattice/kurs06/impl1/source/debouncer.v(19[14] 26[8])
    defparam FilteredSignal_17.GSR = "ENABLED";
    FD1S3IX Counter_52__i3 (.D(n21[3]), .CK(Clock14MHz), .CD(n189), .Q(Counter[3]));   // d:/lattice/kurs06/impl1/source/debouncer.v(20[18:32])
    defparam Counter_52__i3.GSR = "ENABLED";
    LUT4 i171_1_lut (.A(Counter[0]), .Z(n201)) /* synthesis lut_function=(!(A)) */ ;   // d:/lattice/kurs06/impl1/source/debouncer.v(20[18:32])
    defparam i171_1_lut.init = 16'h5555;
    FD1S3IX Counter_52__i0 (.D(n201), .CK(Clock14MHz), .CD(n189), .Q(Counter[0]));   // d:/lattice/kurs06/impl1/source/debouncer.v(20[18:32])
    defparam Counter_52__i0.GSR = "ENABLED";
    FD1S3IX Counter_52__i2 (.D(n21[2]), .CK(Clock14MHz), .CD(n189), .Q(Counter[2]));   // d:/lattice/kurs06/impl1/source/debouncer.v(20[18:32])
    defparam Counter_52__i2.GSR = "ENABLED";
    FD1S3IX Counter_52__i1 (.D(n21[1]), .CK(Clock14MHz), .CD(n189), .Q(Counter[1]));   // d:/lattice/kurs06/impl1/source/debouncer.v(20[18:32])
    defparam Counter_52__i1.GSR = "ENABLED";
    LUT4 i280_3_lut_4_lut (.A(Counter[1]), .B(Counter[0]), .C(Counter[2]), 
         .D(Counter[3]), .Z(n21[3])) /* synthesis lut_function=(!(A (B (C (D)+!C !(D))+!B !(D))+!A !(D))) */ ;   // d:/lattice/kurs06/impl1/source/debouncer.v(20[18:32])
    defparam i280_3_lut_4_lut.init = 16'h7f80;
    LUT4 i266_2_lut (.A(Counter[1]), .B(Counter[0]), .Z(n21[1])) /* synthesis lut_function=(!(A (B)+!A !(B))) */ ;   // d:/lattice/kurs06/impl1/source/debouncer.v(20[18:32])
    defparam i266_2_lut.init = 16'h6666;
    LUT4 i273_2_lut_3_lut (.A(Counter[1]), .B(Counter[0]), .C(Counter[2]), 
         .Z(n21[2])) /* synthesis lut_function=(!(A (B (C)+!B !(C))+!A !(C))) */ ;   // d:/lattice/kurs06/impl1/source/debouncer.v(20[18:32])
    defparam i273_2_lut_3_lut.init = 16'h7878;
    LUT4 i2_3_lut_rep_12 (.A(Counter[3]), .B(Counter[1]), .C(Counter[2]), 
         .Z(n400)) /* synthesis lut_function=(A (B (C))) */ ;   // d:/lattice/kurs06/impl1/source/debouncer.v(20[18:32])
    defparam i2_3_lut_rep_12.init = 16'h8080;
    LUT4 i1_3_lut (.A(ButtonDown_c), .B(n400), .C(ButtonDownFiltered), 
         .Z(n189)) /* synthesis lut_function=(A (B+(C))+!A (B+!(C))) */ ;
    defparam i1_3_lut.init = 16'heded;
    
endmodule
//
// Verilog Description of module \Debouncer(FREQUENCY_MHZ=14,PERIOD_US=1) 
//

module \Debouncer(FREQUENCY_MHZ=14,PERIOD_US=1)  (ButtonUp_c, ButtonUpFiltered, 
            Clock14MHz) /* synthesis syn_module_defined=1 */ ;
    input ButtonUp_c;
    output ButtonUpFiltered;
    input Clock14MHz;
    
    wire Clock14MHz /* synthesis SET_AS_NETWORK=Clock14MHz, is_clock=1 */ ;   // d:/lattice/kurs06/impl1/source/top.v(13[8:18])
    wire [3:0]Counter;   // d:/lattice/kurs06/impl1/source/debouncer.v(13[19:26])
    
    wire n403, Clock14MHz_enable_2, n187;
    wire [3:0]n21;
    
    wire n211;
    
    LUT4 i2_3_lut_rep_15 (.A(Counter[2]), .B(Counter[1]), .C(Counter[3]), 
         .Z(n403)) /* synthesis lut_function=(A (B (C))) */ ;   // d:/lattice/kurs06/impl1/source/debouncer.v(20[18:32])
    defparam i2_3_lut_rep_15.init = 16'h8080;
    LUT4 i1_2_lut_4_lut (.A(Counter[2]), .B(Counter[1]), .C(Counter[3]), 
         .D(Counter[0]), .Z(Clock14MHz_enable_2)) /* synthesis lut_function=(!((((D)+!C)+!B)+!A)) */ ;   // d:/lattice/kurs06/impl1/source/debouncer.v(20[18:32])
    defparam i1_2_lut_4_lut.init = 16'h0080;
    LUT4 i1_3_lut (.A(ButtonUp_c), .B(n403), .C(ButtonUpFiltered), .Z(n187)) /* synthesis lut_function=(A (B+(C))+!A (B+!(C))) */ ;
    defparam i1_3_lut.init = 16'heded;
    FD1S3IX Counter_50__i2 (.D(n21[2]), .CK(Clock14MHz), .CD(n187), .Q(Counter[2]));   // d:/lattice/kurs06/impl1/source/debouncer.v(20[18:32])
    defparam Counter_50__i2.GSR = "ENABLED";
    FD1S3IX Counter_50__i1 (.D(n21[1]), .CK(Clock14MHz), .CD(n187), .Q(Counter[1]));   // d:/lattice/kurs06/impl1/source/debouncer.v(20[18:32])
    defparam Counter_50__i1.GSR = "ENABLED";
    FD1P3AX FilteredSignal_17 (.D(ButtonUp_c), .SP(Clock14MHz_enable_2), 
            .CK(Clock14MHz), .Q(ButtonUpFiltered)) /* synthesis LSE_LINE_FILE_ID=3, LSE_LCOL=4, LSE_RCOL=3, LSE_LLINE=22, LSE_RLINE=27 */ ;   // d:/lattice/kurs06/impl1/source/debouncer.v(19[14] 26[8])
    defparam FilteredSignal_17.GSR = "ENABLED";
    FD1S3IX Counter_50__i0 (.D(n211), .CK(Clock14MHz), .CD(n187), .Q(Counter[0]));   // d:/lattice/kurs06/impl1/source/debouncer.v(20[18:32])
    defparam Counter_50__i0.GSR = "ENABLED";
    FD1S3IX Counter_50__i3 (.D(n21[3]), .CK(Clock14MHz), .CD(n187), .Q(Counter[3]));   // d:/lattice/kurs06/impl1/source/debouncer.v(20[18:32])
    defparam Counter_50__i3.GSR = "ENABLED";
    LUT4 i244_2_lut_3_lut (.A(Counter[1]), .B(Counter[0]), .C(Counter[2]), 
         .Z(n21[2])) /* synthesis lut_function=(!(A (B (C)+!B !(C))+!A !(C))) */ ;   // d:/lattice/kurs06/impl1/source/debouncer.v(20[18:32])
    defparam i244_2_lut_3_lut.init = 16'h7878;
    LUT4 i182_1_lut (.A(Counter[0]), .Z(n211)) /* synthesis lut_function=(!(A)) */ ;   // d:/lattice/kurs06/impl1/source/debouncer.v(20[18:32])
    defparam i182_1_lut.init = 16'h5555;
    LUT4 i251_3_lut_4_lut (.A(Counter[1]), .B(Counter[0]), .C(Counter[2]), 
         .D(Counter[3]), .Z(n21[3])) /* synthesis lut_function=(!(A (B (C (D)+!C !(D))+!B !(D))+!A !(D))) */ ;   // d:/lattice/kurs06/impl1/source/debouncer.v(20[18:32])
    defparam i251_3_lut_4_lut.init = 16'h7f80;
    LUT4 i237_2_lut (.A(Counter[1]), .B(Counter[0]), .Z(n21[1])) /* synthesis lut_function=(!(A (B)+!A !(B))) */ ;   // d:/lattice/kurs06/impl1/source/debouncer.v(20[18:32])
    defparam i237_2_lut.init = 16'h6666;
    
endmodule
//
// Verilog Description of module TSALL
// module not written out since it is a black-box. 
//

//
// Verilog Description of module EdgeDetector
//

module EdgeDetector (ButtonUpFiltered, n402, \CountValue[2] , n4, \Value_3__N_23[2] , 
            Clock14MHz) /* synthesis syn_module_defined=1 */ ;
    input ButtonUpFiltered;
    output n402;
    input \CountValue[2] ;
    input n4;
    output \Value_3__N_23[2] ;
    input Clock14MHz;
    
    wire Clock14MHz /* synthesis SET_AS_NETWORK=Clock14MHz, is_clock=1 */ ;   // d:/lattice/kurs06/impl1/source/top.v(13[8:18])
    
    wire Previous;
    
    LUT4 RisingEdge_I_0_2_lut_rep_14 (.A(Previous), .B(ButtonUpFiltered), 
         .Z(n402)) /* synthesis lut_function=(!(A+!(B))) */ ;   // d:/lattice/kurs06/impl1/source/edge_detector.v(17[24:62])
    defparam RisingEdge_I_0_2_lut_rep_14.init = 16'h4444;
    LUT4 i2_3_lut_4_lut (.A(Previous), .B(ButtonUpFiltered), .C(\CountValue[2] ), 
         .D(n4), .Z(\Value_3__N_23[2] )) /* synthesis lut_function=(A (C (D)+!C !(D))+!A !(B (C (D)+!C !(D))+!B !(C (D)+!C !(D)))) */ ;   // d:/lattice/kurs06/impl1/source/edge_detector.v(17[24:62])
    defparam i2_3_lut_4_lut.init = 16'hb44b;
    FD1S3AX Previous_13 (.D(ButtonUpFiltered), .CK(Clock14MHz), .Q(Previous)) /* synthesis lse_init_val=0, LSE_LINE_FILE_ID=3, LSE_LCOL=15, LSE_RCOL=3, LSE_LLINE=43, LSE_RLINE=49 */ ;   // d:/lattice/kurs06/impl1/source/edge_detector.v(15[7:26])
    defparam Previous_13.GSR = "ENABLED";
    
endmodule
//
// Verilog Description of module PUR
// module not written out since it is a black-box. 
//

